/*
THIS IS AN EXAMPLE OF HOW DATA DRIVEN VOICE APPS ARE WRITTEN. THE ACTUAL
APP IS CONTROLED BY THE "EVENTS.DBF" OUTSIDE OF THE APP. AT STARTUP, 
THIS DBF IS LOADED INTO AN ARRAY WHICH WILL NOW ACT AS OUR EVENT  TABLE.
THIS IS THE SAME CONCEPT THAT THE POPULAR SCRIPTING LANGUAGES USE. 
NOTICE THAT WE CAN CHANGE THE WAY THE PROGRAM FLOWS WITHOUT COMPILING
AND RELINKING OUR APP. ALSO, THIS SAMPLE CODE DEMOS THE ABILITY
OF MODULARIZING YOUR CODE. BY CALLING THE FUNCTIONS AT THE BOTTOM
IF THIS PRG, WE CAN ACCESS ANY OF THE STATIC VARIBLES FROM OUTSIDE OF 
THE MAIN PRG. BUT MORE THAN ANYTHING, THIS LAME PIECE OF CODE DEMONSTATES 
THE ABILITY TO REUSE FUNCTION SETS, ESPECIALLY THE PLAY() FUNCTION.
FEEL FREE TO USE THIS CODE AS YOU WISH
GORDON HAMM, VOICE DATA SYSTEMS

COMPILE 
CLIPPER DEMO -W -N -Q -V
BLINKER @DEMO
*/

#include "PDDIAL.CH"
#include "INKEY.CH"
#define HWIRQ         5  // hardware interrupt of Dialogic board
#define MAXCHAN       4  // maximum number of channels
#define NUMRINGS      1  // number of phone rings before answering
#define TERMDTMF    '#'  // standard terminating DTMF character
#define MNUMRINGS     1  // number of rings to wait before answering

// File wide statics
STATIC LSTATELOOP,;       // terminates execution of the state machine
NCHAN:=0        ,;   // channel of current event
NEVENT               // current event


//// THESE STATIC ARRAYS WILL HOLD DATA FROM EACH CHANNEL
STATIC ACURBLOCK :={},;   // array of current initiate and process code blocks
AFILEHANDLE      :={},;   // array of current file handles opened
M_DTMF           :={},;
MCARGO           :={},;
NEXT_PROC        :={},;
REPEAT           :={} 


/// THESE STATIC ARRAYS ARE WHAT EVENTS.DBF WILL BE LOADED INTO
STATIC MBLOCK :={},;
   PARAMS     :={},;
   P_DESCRIPT :={}

//
*!*****************************************************************************
*!
*!       Function: STARTUP()
*!
*!*****************************************************************************
FUNCTION STARTUP(CHWIRQ)
// initialize the state machine processing.
// can pass the hardware interrupt number from the DOS command line
LOCAL NCHANNEL,;                                  // loop counter for initialization of the channels
NDEVTYPE,;                                  // device type on which the error occured
NEVENTDATA,;                                // data variable passed back with the event code
NERR,;                                      // init error code
NHWIRQ,;                                    // hardware interrupt for board
NINKEY,;                                    // key input value
NMAXCHAN := 0                             // maximum number of channels

FIELD PROC_DESC,BLOCK,PARAMETERS,P1,P2,P3,P4,P5,P6,P7,P8,P9,ON_ERROR

// If no hardware interrupt was passed as a parameter, set the hardware
// interrupt value to the one defined by the manifest constant.
IF EMPTY(CHWIRQ)
   NHWIRQ := HWIRQ
ELSE
   // convert the hardware interrupt to a numeric.
   NHWIRQ := VAL(CHWIRQ)
ENDIF

CLEAR SCREEN
SET CURS OFF

//// MAKE SURE THE GLOBAL VAP IS FOUND IF NEEDED
IF .NOT. FILE('GLOBAL.VAP')
   WINMSG('WARNING, GLOBAL.VAP NOT FOUND')
   INKEY(0)
ENDIF
// Start the voice system
IF (NERR := PD_INIT(NHWIRQ, @NMAXCHAN,;
      C_LC + C_RING + C_OFFH + C_ONH, MNUMRINGS)) == 0
   // there was no error doing the initialization of the driver, etc.
   

      SELE 0
      USE EVENTS
      DO WHILE .NOT. EOF()
         @ 10,10 SAY RECNO() // I USE THIS COUNTER TO DISPLAY THE RECNO()
                             // OF THE RECORD BEING LOADED INTO ARRAY. BY 
                             // DOING THIS YOU CAN SEE LOAD ERRORS IF ANY.

         AADD(P_DESCRIPT,TRIM(PROC_DESC))
         AADD(MBLOCK,{ &('{ || '+TRIM(BLOCK)+'INIT('+TRIM(PARAMETERS)+') }'),; 
                       &('{ || '+TRIM(BLOCK)+'PROC('+TRIM(PARAMETERS)+') }') } ) 
         AADD(PARAMS,TRIM(PARAMETERS)) 
         AADD(NEXT_PROC,{P1,P2,P3,P4,P5,P6,P7,P8,P9,ON_ERROR} ) 
         SKIP
       ENDDO
      USE

      FOR NCHANNEL := 1 TO NMAXCHAN
         // One array element per channel.  Each array element contains
         // a two element array containing the next initiate function and
         // the next process function.  All channels start on-hook.
         AADD(M_DTMF,'')  // STORE DTMFS / NUMBERS HERE
         AADD(MCARGO,'')  // FOR HOLDING WHATEVER
         AADD(ACURBLOCK,1)   // SET TO FIRST PROC IN ARRAY // ON HOOK
         // a storage space to keep the channel's file handle
         AADD(AFILEHANDLE, 0)
         AADD(REPEAT,{0,0})
      NEXT
      
      PD_GLOBAL('loopsig', 1)           // generate event on dropped line
      PD_GLOBAL('termdtmf', '@')        // terminate on any character
      
      // Loop to call the voice handle
      // processing events with the state machine
      // yo, this is the "state machine" processing loop>>>>>
      DO WHILE (NINKEY := INKEY()) <> K_ESC

         // Did an event occur?
         IF PD_GETEVENT(@NCHAN, @NEVENT, @NDEVTYPE, @NEVENTDATA) == -1
            // Placing this message in here slows us down a little.  It's
            // certainly not necessary.  Its just an example of how you can
            // put your own function calls which can do other types of
            // processing inside the state machine loop!
            WINMSG('Processing Events, ESC to exit')
            
            // Process the event and save the next channel state
            // (execute the "PROCESS" function)
            EVAL(MBLOCK[aCurBlock[NCHAN],2])
            
            // execute the INITIATE function.  (this sets the code blocks
            // defining the next activity to execute.)
            
            IF (NERR := EVAL(MBLOCK[aCurBlock[NCHAN],1])) <> 0
               // process the error message
               PD_ERROR(NERR)
            ENDIF
         ENDIF
      ENDDO
      
      // Shut down the voice system
      IF (NERR:=PD_DEINIT(NMAXCHAN)) <> 0
         WINMSG( ALLTRIM(PD_D4XERR(NERR)) )
      ENDIF
   ELSE
      WINMSG(  ALLTRIM(PD_D4XERR(NERR)) )
      INKEY(10)
   ENDIF
   CLS
   CLOSE ALL
   RETURN NIL
   
   //
   FUNCTION ONHOOKINIT()
   // Initiate function to set the channel on hook.
   LOCAL NRETVAL
   
   PD_DISPMSG(GET_CURPROC()+' INIT')
   
   // Set the current channel on hook
   NRETVAL := PD_SETHOOK(NCHAN, H_ONH)
   RETURN NRETVAL
   
   //
   FUNCTION ONHOOKPROC()
   // Process function to set the channel on hook.
   PD_DISPMSG(GET_CURPROC()+' PROC')
   // Proceed to wait for a ring
   AS_BLOCK(1)   ///  SEE P1 IN ACITONS.DBF
   RETURN NIL
   
   //
   FUNCTION RINGINIT()
   // Initiate function to wait for a channel to ring.
   PD_DISPMSG(GET_CURPROC()+' INIT')
   
   // Clear the dtmf buffer for the channel and wait for a call.
   PD_CLRDTMF(NCHAN)
  
   RETURN E_SUCC   // always successful
   
   //
   FUNCTION RINGPROC()
   // Process function for when the channel rings.
   PD_DISPMSG(GET_CURPROC()+' INIT')
   
   // When a call is detected, set state to go off hook
   IF NEVENT == T_RING
      // Proceed to take the channel off hook
      AS_BLOCK(1)
   ELSE
      // Unexpected event detected, must wait for another ring
      AS_BLOCK(10)  // DO ERROR EVENT
   ENDIF
   
   RETURN NIL
   
   //
   FUNCTION OFFHOOKINIT()
   // Initiate function to take the channel off hook.
   LOCAL NRETVAL
   PD_DISPMSG(GET_CURPROC()+' INIT')
   // Channel activity detected, go off hook
   NRETVAL := PD_SETHOOK(NCHAN, H_OFFH)
   
   RETURN NRETVAL
   
   //
   FUNCTION OFFHOOKPROC()
   // Process function to determine if the channel was answered and stay off hook.
   PD_DISPMSG(GET_CURPROC()+' PROC')
   
   // When channel goes off hook proceed
   IF NEVENT == T_OFFH
     // IT IS HERE YOU COULD REDIRECT THE PROGRAM BASED ON THE CALLING LINE #
     // FOR EXAMPLE
     // IF NCHAN==1  // IF CALL CAME IN ON LINE 1 
     //   AS_BLOCK(1) // GO TO THIS EVENT
     // ELSE
     //   AS_BLOCK(2) // OTHERWISE GO TO THIS EVENT BLOCK
     // ENDIF
     AS_BLOCK(1)
   ELSE
      // Unexpected event detected, must go back on hook
      AS_BLOCK(10)   // GO TO ERROR
   ENDIF
   
   RETURN NIL
   
   //
   FUNCTION WINMSG(CMESSAGE)
   // display informative excuse for processing pauses
   // this is really a poor excuse for a message window, but its simple!
   LOCAL NLEFT,;
      NRIGHT
   
   @ 8,1 CLEAR TO 12,79
   
   NLEFT  := MAXCOL()/2 - LEN(CMESSAGE)/2 - 1
   NRIGHT := MAXCOL()/2 + LEN(CMESSAGE)/2 + 2
   
   // draw a box
   @ 9, NLEFT TO 11, NRIGHT + 1 DOUBLE COLOR '+R/B'
   
   @ 10, NLEFT + 1 SAY PADC(CMESSAGE, NRIGHT - NLEFT) COLOR 'R/B'
   
   RETURN NIL
   
   //
   FUNCTION REMTERMDTMF(CDTMFBUF)
   // Removes the terminating character DTMF character if it is the standard
   // DTMF terminating character.
   
   // Ensure rightmost character is terminating character
   IF RIGHT(CDTMFBUF, 1) == TERMDTMF
      CDTMFBUF := LEFT(CDTMFBUF, LEN(CDTMFBUF) - 1)
   ENDIF
   
   RETURN CDTMFBUF
   


  //------------------------------------------------------------------------

   FUNCTION AS_DTMF(MDATA)
   M_DTMF[NCHAN]:=MDATA
   RETURN NIL

   FUNCTION GET_DTMF()
   RETURN M_DTMF[NCHAN]
   
   FUNCTION GET_CURPROC()
   RETURN 'CHAN '+LTRIM(STR(NCHAN))+' '+P_DESCRIPT[ACURBLOCK[NCHAN]]
   
   FUNCTION GET_CHAN()
   RETURN NCHAN
   
   FUNCTION GET_EVENT()
   RETURN NEVENT
   
   FUNCTION AS_BLOCK(MNEXTPROC)   /// ASSIGN THE NEXT BLOCK
   ACURBLOCK[NCHAN]:= NEXT_PROC[ACURBLOCK[NCHAN],MNEXTPROC]
   RETURN NIL
   
   FUNCTION GET_BLOCK()
   RETURN ACURBLOCK[NCHAN]
   
   FUNCTION AS_HANDLE(HANDLE)
   AFILEHANDLE[NCHAN]:=HANDLE
   RETURN NIL
   
   FUNCTION GET_HANDLE()
   RETURN AFILEHANDLE[NCHAN]
   
   
   FUNCTION AS_CARGO(MDATA)
   MCARGO[NCHAN]:=MDATA
   RETURN NIL
   
   FUNCTION GET_CARGO()
   RETURN MCARGO[NCHAN]

   
   FUNCTION GET_REPEAT()
   RETURN REPEAT[NCHAN,2]  // FIRST ELE IS PROC  SECOND IS COUNTER
   
   FUNCTION AS_REPEAT()
   REPEAT[NCHAN,2]++
   RETURN NIL
   
   FUNCTION REPEAT_RESET()
   REPEAT[NCHAN,2]:=0  // RESET COUNTER
   RETURN NIL
