/// COMPILE
/// CLIPPER FUNCTS -W -N -Q -V
#include "PDDIAL.CH"
#include "INKEY.CH"



	FUNCTION PLAYINIT(FILE,CL_DTMF,TERM)
	LOCAL NHANDLE,;
		NRETVAL,NCHAN
	NCHAN:=GET_CHAN()
	PD_RESET()
	PD_DISPMSG(GET_CURPROC()+' INIT')
  PD_GLOBAL('TERMDTMF',IF(VALTYPE(TERM)=='C',TERM,'')) // GET TERMINATING CHAR
	IF VALTYPE(CL_DTMF) == 'L'  /// CLEAR BUFFER
		IF CL_DTMF
		  PD_CLRDTMF(NCHAN)
		ENDIF
	ENDIF
	NRETVAL := PD_PLAY(NCHAN, FILE+'.vox', @NHANDLE)
	AS_HANDLE(NHANDLE)              // save the handle
	
	RETURN NRETVAL
	
	//
	FUNCTION PLAYPROC()
	LOCAL NEVENT
	NEVENT:=GET_EVENT()
	PD_DISPMSG(GET_CURPROC()+' PROC')
	IF NEVENT == T_EOF .OR. NEVENT == T_TERMDT    // here check for other states
		// normal file play completion, go into menu input process.
		AS_BLOCK(1)
	ELSE
		// hang-up next of the file was abnormally played.
		AS_BLOCK(10)
	ENDIF
	
	// Close the most recently opened file
	PD_VOXCLOSE(GET_HANDLE(GET_CHAN()))
	
	RETURN NIL
	

	//
	// play number back to user  
	//---------------------------------------------------------
	FUNCTION PLAYNUMINIT(CLEAR,PLAYTYPE)
	LOCAL NHANDLE,;
		NRETVAL,NCHAN
	 NCHAN:=GET_CHAN()
	PD_RESET()
	PD_DISPMSG('PlayNumInit(' + ALLTRIM(GET_DTMF()) + ')' )
	// Play the number entered.
	IF VALTYPE(CLEAR)=='L' // CLEAR DTMF BUFFER FIRST ??
		PD_CLRDTMF(NCHAN)
	ENDIF
	NRETVAL := PD_PLAYNUM(NCHAN,VAL(GET_DTMF()), PLAYTYPE)
	RETURN NRETVAL
	
	//
	FUNCTION PLAYNUMPROC()
	// Process function after playing back the number entered.
	PD_DISPMSG(GET_CURPROC()+' PROC')
	// move on
	AS_BLOCK(1)
	
	RETURN NIL


/// NOT USED IN DEMO BUT COULD BE
///_____________________________________________________________________________
	FUNCTION PAUSEINIT(HOWLONG)
	LOCAL NRETVAL
	// wait for user to enter packet number
	PD_DISPMSG(GET_CURPROC()+' INIT')
	PD_RESET()
	IF HOWLONG <> NIL
		PD_GLOBAL('MAXSIL',IF(VALTYPE(HOWLONG)=='N',HOWLONG,0))
	ENDIF
	PD_GLOBAL('TERMDTMF','@')
	PD_GLOBAL('MAXDTMF',1)
	NRETVAL := PD_GETDTMFS(GET_CHAN())
	RETURN NRETVAL
	
	//
	
	FUNCTION PAUSEPROC()
	LOCAL CDTMFBUF,;   // the contents of the DTMF buffer
	NNUMBER,X,NEVENT
	NEVENT:=GET_EVENT()
	// the number value entered
	
	PD_DISPMSG(GET_CURPROC()+' PROC')
	
	// Check for terminating dtmf
	IF NEVENT == T_TERMDT .OR. NEVENT == T_SIL .OR. NEVENT== T_MAXDT
		CDTMFBUF := PD_GETBUF(GET_CHAN())
		AS_BLOCK(1)
	ELSE
		AS_BLOCK(10)
	ENDIF
	
	RETURN NIL

//_____________________________________________________________________________
// FUNCTION USED TO GET DIGITS

	FUNCTION ENT_DIGITINIT(MAXNUMBER,DELAY)
	LOCAL NRETVAL
	PD_DISPMSG(GET_CURPROC()+' INIT')
	PD_RESET()
	PD_GLOBAL('ISRWB',1)
	PD_GLOBAL('INTRDIG',IF(VALTYPE(DELAY)=='N',DELAY,5))
	PD_GLOBAL('TERMDTMF','*')
	PD_GLOBAL('MAXDTMF',IF(VALTYPE(MAXNUMBER)=='N',MAXNUMBER,1))
	NRETVAL := PD_GETDTMFS(GET_CHAN())
	
	RETURN NRETVAL
	
	//
	
	FUNCTION ENT_DIGITPROC(MAXNUMBER,SILENCE)
	LOCAL CDTMFBUF,;                                  // the contents of the DTMF buffer
	NNUMBER,NEVENT
	NEVENT:=GET_EVENT()
	// the number value entered
	
	PD_DISPMSG(GET_CURPROC()+' PROC')
	
	// Check for terminating dtmf
	IF NEVENT == T_TERMDT .OR. NEVENT == T_IDTIME .OR. NEVENT == T_MAXDT
		CDTMFBUF := PD_GETBUF(GET_CHAN())
		AS_BLOCK(1)
		AS_DTMF(CDTMFBUF) // STORE DTMF FOR LATER
	ELSE
		AS_BLOCK(10)
	ENDIF
	
	RETURN NIL
	


	//______________________________________________________________________
	// USER MENU
	// MTIME IS MAX TIME YOU WILL WAIT FOR KEY TO BE PUSHED
 
	// CHOICES IS HOW MANY CHOICES YOU WANT ON THE MENU
	// THE AS_BLOCK(8) WILL BE THE EVENT TO GO TO IF THE USER DOES 
	// NOTHING OR HITS THE WRONG KEY

	// AS_BLOCK(9) IS IF THEY HIT A STAR KEY, EXIT...
	
	// REPEATS IS HOW MANY TIMES YOU WANT THIS FUNCTION REPEATED BEFORE
	// IT GIVES UP AND DOES SOMETHING ELSE LIKE QUIT 

	//
	FUNCTION CHOICEINIT(MTIME,CHOICES,REPEATS)
	LOCAL NRETVAL
	PD_DISPMSG(GET_CURPROC())
	PD_RESET()
	PD_GLOBAL('MAXSEC',20)  /// FUNCTION WILL NEVER LAST MORE THAN 20 SEC 
	PD_GLOBAL('ISXRWB',1)
	PD_GLOBAL('INTRDIG',IF(VALTYPE(MTIME)=='N',MTIME,30))
	PD_GLOBAL('TERMDTMF','@')
	NRETVAL := PD_GETDTMFS(GET_CHAN())
	RETURN NRETVAL
	
	//
	
	FUNCTION CHOICEPROC(MTIME,CHOICES,REPEATS)
	LOCAL CDTMFBUF,X,FOUNDONE:=.F.,;               // the contents of the DTMF buffer
	NNUMBER,;                 // the number value entered
	NCHAN,NEVENT,REPEAT_COUNT
	NCHAN:=GET_CHAN()
	NEVENT:=GET_EVENT()
	REPEAT_COUNT:=GET_REPEATS()

	IF(VALTYPE(REPEATS)<>'N',REPEATS:=10,NIL ) 
	IF(VALTYPE(CHOICES)<>'N',CHOICES:=1,NIL)
	PD_DISPMSG(GET_CURPROC())

	// Check for terminating dtmf
	// Check for terminating dtmf

IF NEVENT == T_TERMDT .OR. NEVENT == T_IDTIME 
		CDTMFBUF := PD_GETBUF(NCHAN)

	IF CDTMFBUF $ '1234567890*'

		FOR X=1 TO CHOICES
		 IF VAL(CDTMFBUF)==X
			 REPEAT_RESET()
			 AS_BLOCK(X)
			 FOUNDONE:=.T.
		 ENDIF
		NEXT

		IF .NOT. FOUNDONE
		  IF CDTMFBUF='*' /// EXIT KEY //
			 AS_BLOCK(9) /// EXIT MENU IF "*" KEY PUSHED //
			 REPEAT_RESET()
		  ELSE  
 
			 IF REPEAT_COUNT < REPEATS
				AS_REPEAT()
				AS_BLOCK(8) // INVALID CHOICE  DO SOMETHING, recycle or loop ??
			 ELSE
				REPEAT_RESET()
				AS_BLOCK(10)  /// error, do something
			 ENDIF
		  ENDIF
		ENDIF
	  ELSE   
		  IF REPEAT_COUNT < REPEATS
				AS_REPEAT()
				AS_BLOCK(8) // INVALID CHOICE  DO SOMETHING, recycle or loop ??
			 ELSE
				REPEAT_RESET()
				AS_BLOCK(10)  /// error, do something
			 ENDIF
	ENDIF
ELSE
  REPEAT_RESET()
  AS_BLOCK(10)  /// error, do something
ENDIF
RETURN NIL






FUNCTION PLAYDATEINIT(PASSDATE)
/// PLAY DATE
LOCAL NRETVAL,MDATE
PD_RESET()
PD_DISPMSG(GET_CURPROC())  
IF(EMPTY(PASSDATE),MDATE:=DATE(),MDATE:=CTOD(PASSDATE))

NRETVAL := PD_PLAYDATE(GET_CHAN(),MDATE)
					  
RETURN NRETVAL


FUNCTION PLAYDATEPROC()
PD_DISPMSG(GET_CURPROC())
AS_BLOCK(1)
RETURN NIL



//_____________________________________________________________________________
	FUNCTION GETPROMINIT()
	LOCAL NRETVAL
	PD_RESET()
	PD_DISPMSG(GET_CURPROC())
	PD_GLOBAL('ISXRWB',1)
	PD_GLOBAL('INTRDIG',4)
	PD_GLOBAL('TERMDTMF','#')
	PD_GLOBAL('MAXDTMF',4)
	NRETVAL := PD_GETDTMFS(GET_CHAN())
	
	RETURN NRETVAL
	
	//
	
	FUNCTION GETPROMPROC()
	LOCAL CDTMFBUF,;                                  // the contents of the DTMF buffer
	NNUMBER,NEVENT,NCHAN
NCHAN:=GET_CHAN()
NEVENT:=GET_EVENT()
	// the number value entered
	
	PD_DISPMSG(GET_CURPROC())
	
	// Check for terminating dtmf
	IF NEVENT == T_TERMDT .OR. NEVENT == T_TIME .OR. NEVENT == T_MAXDT
		CDTMFBUF := PD_GETBUF(NCHAN)+'.VOX'
		CDTMFBUF := STRTRAN(CDTMFBUF,'#','')
		IF VAL(CDTMFBUF) < 1 .OR. .NOT. FILE(CDTMFBUF)  // put back to 4
			AS_BLOCK(2) // BAD NUMBER
			AS_CARGO(CDTMFBUF)
		ELSE
			AS_CARGO(CDTMFBUF)
			AS_BLOCK(1)
		ENDIF
		AS_DTMF(CDTMFBUF)
	ELSE
		AS_BLOCK(10)
	ENDIF
	
	RETURN NIL


FUNCTION RECpromINIT()
// Initiate function to record a message.

LOCAL NHANDLE,;
	NRETVAL:=0

PD_RESET()

// Set global values.
PD_GLOBAL('maxsec',60) // maximum message
PD_GLOBAL('termdtmf',     '@')    // terminate on any dtmf
PD_GLOBAL('maxsil',         5)    // terminate after 4 seconds of silence
PD_GLOBAL('rwbflags', RW_TONE)    // enable beep before record
PD_GLOBAL('rwbdata1',       1)    // .2 second beep
PD_CLRDTMF(GET_CHAN())
NRETVAL := PD_RECFILE(GET_CHAN(),get_CARGO(), @NHANDLE, 0,.F.)
PD_RESET()
AS_HANDLE(NHANDLE)

RETURN NRETVAL


//
FUNCTION RECpromPROC()
LOCAL NEVENT,NCHAN
NCHAN:=GET_CHAN()
NEVENT:=GET_EVENT()

// Process function after recording a message.
// When record is complete
IF nEVENT == T_TERMDT .OR. nEVENT == T_SIL .OR. nEVENT == T_TIME
	PD_CLRDTMF(nCHAN)
	AS_BLOCK(1)
ELSE
	AS_BLOCK(10)
ENDIF

// Close the most recently opened file
PD_VOXCLOSE(GET_HANDLE(nCHAN))

RETURN NIL



FUNCTION PLAYPROMINIT()
// Initiate function to handle playing back the recorded message.
LOCAL NHANDLE,;
	NRETVAL
	
PD_RESET()
PD_GLOBAL('termdtmf','@')    // terminate on any dtmf
NRETVAL := PD_PLAY(GET_CHAN(),GET_CARGO(), @NHANDLE,0)
AS_HANDLE(NHANDLE)
RETURN NRETVAL



FUNCTION PLAYPROMPROC()
LOCAL MEVENT
MEVENT:=GET_EVENT()
IF MEVENT==T_EOF .OR. MEVENT==T_TERMDT
// Process function after playing back the recorded message.
// Close the most recently opened file
PD_VOXCLOSE(GET_HANDLE(GET_CHAN()))
AS_BLOCK(1)
ELSEIF MEVENT==100  // NO MORE MESSAGES
AS_BLOCK(2)
ELSE  // AN ERROR
AS_BLOCK(10)
ENDIF
RETURN NIL



