/**
  Ŀ
 ݳ                                                                          
 ݳ   Program : PAL.PRG                                                      
 ݳ   Purpose : Voice system program.                                        
 ݳ Written By: Craig Snyder & Peter Steele                                  
 ݳThe procedures in this file are Copyright (C) 1988-1992 by the            
 ݳPinnacle dEVELOPMENT Corporation. These programs are the sole property of 
 ݳPinnacle dEVELOPMENT Corporation. They contain confidential information   
 ݳand are a trade secret of Pinnacle dEVELOPMENT Corporation. They are being
 ݳsupplied to you with the express understanding that the information       
 ݳcontained herein be held in confidence by you.  This software is not to be
 ݳcopied, distributed, or displayed to third parties without the express    
 ݳwritten consent of Pinnacle dEVELOPMENT Corporation, and must be returned 
 ݳupon request.  Any use of these programs without the express written      
 ݳconsent of Pinnacle dEVELOPMENT Corporation, is strictly forbidden.       
 ݳThis software and any companion  documentation are protected by U.S.      
 ݳCopyright law (Title 17 United States Code).  Unauthorized reproduction   
 ݳand/or sale may result in imprisonment of up to one year and fines of up  
 ݳto $10,000 per infraction (17 USC 506).  Copyright infringers may also be 
 ݳsubject to civil liability.  Pinnacle dEVELOPMENT is an independent       
 ݳcorporation incorporated under the laws of the state of Texas, U.S.A.     
 
 
   NEED TO TEST MANIFOLDS

REVISION HISTORY:

 Date        Revision
09-10-92 CS Initial Cut
01-11-93 PS Major revisions for EPA reconciliation
                                                                           */
EXTERN PC_MEMORY
EXTERN O_APPEND

#include "PINNSTD.CH"
#include "CLASS(Y).CH"
#include "PDDIAL.CH"

#define MNUMRINGS       1
#define MINKEYDELAY     .05

#define MINITIATE       1
#define MMAXRETRY       3
#define MMAXSECLEV      3
#define MMINSECLEV      1
#define MPROCESS        2
#define MTERMDTMF       '#'
#define MVERSION        'V1.01'

#define MRECNO          1

#define T_APPEVT      100

#define oChannel aChan[nChan]

// for pd_playNum different modes of speach
#define GALLONS 'G'
#define DOLLARS '$'
#define DIGITS  'D'

// File wide statics
STATIC cGByeVox
STATIC cIntroVox
STATIC cSecVox
STATIC nChan                                     // the current channel number
STATIC nEvent
STATIC aChan            := {}                    // an array of channel objects

//
FUNCTION PAL(cIntroParm, cSecParm, cGByeParm, nHWIRQ, nStore)

LOCAL bF1Func,;
      bOldErrBlock      := ErrorBlock({|oErr| PalError(oErr) } ),;
      nDevType,;
      nErr,;
      nEventData,;
      nIdx,;
      nInKey,;
      nMaxChan

// Verify introductory file to play
DEFAULT cGByeParm  TO 'GOODBYE.VOX',;
        cIntroParm TO 'WELCOME.VOX',;
        cSecParm   TO 'LEVEL1.VOX',;
        nHWIRQ     TO 5,;
        nStore     TO 9999

// Verify parameter files to end in '.VOX'
cGByeVox  := VoxExt(cGByeParm)
cIntroVox := VoxExt(cIntroParm)
cSecVox   := VoxExt(cSecParm)

// Determine if running as a standalone program
// replaces the startup for Oasis in sysprocs.
// StartUp()

SETCURSOR(SC_NONE)
bF1Func := SETKEY(K_F1, NIL)         // K_F1 set key must be turned off

SYS_CLR_SCR(' Voice System ' + MVERSION)
HELP_LINE('ESC-Exit')


// Initialize the voice system
WinMsg(765)

// Start the voice system
IF (nErr := pd_init(nHWIRQ, @nMaxChan,;
                    C_LC + C_RING + C_OFFH + C_ONH, MNUMRINGS)) == 0
   // Open DBFs
   SETAREA('TGASRECO', 'TGASRECO',, 'GASRECON')
   SETAREA('VOICDICT', 'VOICDICT')
   SETAREA('VOICMSG',  'VOICMSG')
   SETAREA('VOICUSER', 'VOICUSER')
   SETAREA('VOICLAST', 'VOICLAST')
   SETAREA('VOICMENU', 'VOICMENU')
   SETAREA('VOICPRMP', 'VOICPRMP')
   SET RELATION TO VOICPRMP->menu_id INTO VOICMENU

   // Set initial state: re-initialize channel array
   aChan := {}
   FOR nIdx := 1 TO nMaxChan
      AADD(aChan, Channel():New(cGByeVox, cIntroVox, cSecVox,;
                                {{ || OnHookInit() }, { || OnHookProc() }}))
   NEXT

   // set globals to start with
   pd_global('loopsig', 1)                        // generate event on dropped line
   pd_global('termdtmf', '@')                     // terminate on any character
   // Loop to call the voice handler
   // processing events with the state machine
   WinMsg(766)
   DO WHILE (nInKey := INKEY(MINKEYDELAY)) <> K_ESC
      // Did an event occur?
      IF pd_getEvent(@nChan, @nEvent, @nDevType, @nEventData) == -1
         // Process the event and save the next channel state
         EVAL(oChannel:aCurBlock[MPROCESS])

         // Initiate the new state checking the error code returned
         IF (nErr := EVAL(oChannel:aCurBlock[MINITIATE])) <> 0
            pd_error(nErr)
         ELSE
            // reset timeout value
            pd_Global('maxsec', oChannel:nTimeOut)
         ENDIF
      ENDIF
   ENDDO

   // Shut down the voice system
   IF pd_deinit(nMaxChan) <> 0
      ANY_KEY(ALLTRIM(pd_d4xerr(nErr)), 0, .T., 18)
   ENDIF
   // Close all databases
   CLOSE GASRECON
   CLOSE VOICDICT
   CLOSE VOICMSG
   CLOSE VOICUSER
   CLOSE VOICLAST
   CLOSE VOICMENU
   CLOSE VOICPRMP

ELSE
  // display the error from initialization
  ANY_KEY(ALLTRIM(pd_d4xerr(nErr)), 0, .T., 18)
ENDIF


// reset so we can find 9999's parameters in the parameter file
aChan := {}
AADD(aChan, channel():new('','','',{ {|| NIL}, {|| NIL} }))
nChan := 1
oChannel:cLevel1 := PADR(NTOC(9999), 10)

ErrorBlock(bOldErrBlock)

RETURN NIL

//
FUNCTION OnHookInit()

// Initiate function for putting the channel on hook.

LOCAL nRetVal

pd_dispMsg('OnHook')
oChannel := Channel():New(cGByeVox, cIntroVox, cSecVox,;
                              {{ || OnHookInit() }, { || OnHookProc() }})

nRetVal := pd_setHook(nChan, H_ONH)

RETURN nRetVal

//
FUNCTION OnHookProc()

// Process function for a putting the channel on hook.

pd_dispMsg('OnHookProc')
WinMsg('Hanging up line')

oChannel:aCurBlock := {{ || RingInit() }, { || RingProc() }}

RETURN NIL

//
FUNCTION RingInit()

// Initiate function for waiting for a channel to ring.

pd_dispMsg('RingInit')

// Clear the dtmf buffer and wait for a call.
pd_clrDTMF(nChan)

RETURN E_SUCC  // always successful

//
FUNCTION RingProc()

// Process function for when the channel rings.

// If a call is detected, set state to go off hook
IF nEvent == T_RING
  pd_dispMsg('Ring Detected')
  oChannel:aCurBlock := {{ || OffHookInit() }, { || OffHookProc () }}
ELSE
  // Another event detected, reset to wait for a ring
  pd_dispMsg('No Change')
  oChannel:aCurBlock := {{ || RingInit() }, { || RingProc() }}
ENDIF

RETURN NIL

//
FUNCTION OffHookInit()

// Initiate function to take the channel off hook.

LOCAL nRetVal

pd_dispMsg('OffHook')

// Answer the channel
nRetVal := pd_setHook(nChan, H_OFFH)

RETURN nRetVal

//
FUNCTION OffHookProc()

// Process function to determine if the channel was answered and stay off hook.

IF nEvent == T_OFFH
  pd_dispMsg('Line active ' + NTOC(nChan))
  oChannel:aCurBlock := {{ || IntroInit() }, { || IntroProc() }}
ELSE
  pd_dispMsg('Hanging Up')
  oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookInit() }}
ENDIF

RETURN NIL

//
FUNCTION IntroInit()

// Initiate function to handle playing the introductory message.

LOCAL nHandle,;
      nRetVal

// set for any key termination
pd_global('termdtmf', '@')

// Play the file for the appropriate security level
pd_dispMsg('Play ' + oChannel:cIntroVox)

// Play the file
nRetVal := pd_play(nChan, oChannel:cIntroVox, @nHandle)
oChannel:nHandle := nHandle

RETURN nRetVal

//
FUNCTION IntroProc()

// Process function after the introductory message has played.

// Close the most recently played file
pd_dispMsg('Close ' + oChannel:cIntroVox)
pd_VOXClose(oChannel:nHandle)

// File completion means play security input messages
IF nEvent == T_EOF .OR. nEvent == T_TERMDT
  oChannel:aCurBlock := {{ || SecInit() }, { || SecProc() }}
ELSE
  LogInfo('IntroProc unrecognized event:' + NTOC(nEvent))
  oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}
ENDIF

RETURN NIL

//
FUNCTION SecInit()

// Initiate function to handle playing various levels of security files.

LOCAL nHandle,;
      nRetVal

// set for any key termination
pd_global('termdtmf', '@')

// Play the file for the appropriate security level
pd_dispMsg('Play ' + oChannel:cSecVox)

// Play the file
nRetVal := pd_play(nChan, oChannel:cSecVox, @nHandle)
oChannel:nHandle := nHandle

RETURN nRetVal

//
FUNCTION SecProc()

// Process function to request security input.

// Close the most recently played file
pd_VOXClose(oChannel:nHandle)

// File completion means get security input
IF nEvent == T_EOF .OR. nEvent == T_TERMDT
  oChannel:aCurBlock := {{ || SecInpInit() }, { || SecInpProc() }}
ELSE
  LogInfo('SecProc unrecognized event:' + NTOC(nEvent))
  oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}
ENDIF

RETURN NIL

//
FUNCTION SecInpInit()
// initialize login

LOCAL nRetVal

pd_dispMsg('Security level ' + NTOC(oChannel:nGetSecLev) + ' init')

// set for # key termination
pd_global('termdtmf', '#')

nRetVal := pd_getDTMFs(nChan)

RETURN nRetVal

//
FUNCTION SecInpProc()
// enter logon information
pd_dispMsg('Security Level ' + NTOC(oChannel:nGetSecLev) + ' Proc')

// Check for terminating dtmf
IF nEvent == T_TERMDT
  // Perform security validation for the current security level
  IF SecLevel()
    // login attempt was ok.
    WinMsg('User ' + ALLTRIM(VOICUSER->level1) + ':' + ALLTRIM(VOICUSER->user, 20) + ' on line.' )
    IF oChannel:nGetSecLev >= MMINSECLEV .AND.;
       oChannel:nGetSecLev <= MMAXSECLEV

      // Proceed to next security level
      oChannel:aCurBlock := {{ || SecInit() }, { || SecProc() }}

    ELSEIF oChannel:nGetSecLev > MMAXSECLEV
      // we are all logged on, everything's hunky-dory.
      // set the territory number.  (this assumes that the record
      // pointer in voicuser is still proper for our channel.)

      oChannel:cTerritory := VOICUSER->elsgroup

      // Determine if any messages need to be played
      oChannel:aCurBlock := GenMsg()
    ENDIF

  ELSEIF oChannel:nSecRetry > MMAXRETRY
    // Number of retries exceeded
    oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}

  ELSE
    // Set the next functions after invalid functions
    oChannel:aNextBlock := {{ || SecInit() }, { || SecProc() }}

    // Play invalid
    oChannel:aCurBlock := {{ || InvalidInit() }, { || InvalidProc() }}
  ENDIF
ELSE
  // event was not a terminating character
  LogInfo('SecInpProc unrecognized event:' + NTOC(nEvent))
  oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}

ENDIF

RETURN NIL

//
FUNCTION MsgInit()
// initialize message play
LOCAL cFile,;
      nHandle,;
      nRetVal

// Position to the correct general message record
VOICMSG->(oChannel:GotoCurRec())
cFile := VoxExt(VOICMSG->voxfile)

pd_dispMsg('Play ' + cFile)

// set for any key termination
pd_global('termdtmf', '@')

// Play the file
nRetVal := pd_play(nChan, cFile, @nHandle)
oChannel:nHandle := nHandle

RETURN nRetVal

//
FUNCTION GenMsgProc()
// general broadcast message playback.
LOCAL bEof              := { || VOICMSG->msg_id == oChannel:cGenMsgId .AND.;
                                VOICMSG->sequence <= oChannel:nGenMsgMax }


// Close the most recent file played
pd_VOXClose(oChannel:nHandle)

// End of file, otherwise put line on hook
IF nEvent == T_EOF .OR. nEvent == T_TERMDT
  // Ensure message meets play conditions
  IF VOICMSG->(oChannel:SkipRec(bEof))
    oChannel:aCurBlock := {{ || MsgInit() }, { || GenMsgProc() }}
  ELSE
    oChannel:aCurBlock := UserMsg()
  ENDIF
ELSE
  LogInfo('GenMsgProc unexpected event:' + NTOC(nEvent))
  oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}
ENDIF

RETURN NIL

//
FUNCTION UserMsgProc()
// checks status of user message play, and starts data entry processing
LOCAL bEof

// Close the most recent file played
pd_VOXClose(oChannel:nHandle)

// End of file, otherwise put line on hook
IF nEvent == T_EOF .OR. nEvent == T_TERMDT
  // Goto current VOICMSG record
  VOICMSG->(oChannel:GotoCurRec())

  // Deleted status applies only to messages with a play max greater than 0
  IF VOICMSG->playmax > 0
    IF RECLOCK(STDWAIT)
      REPLACE VOICMSG->playcount WITH VOICMSG->playcount + 1

      // Deleted status determined when play count equals play max
      IF VOICMSG->playcount == VOICMSG->playmax
        REPLACE VOICMSG->deldate WITH DATE()
        VOICMSG->(DBDELETE())
      ENDIF
      VOICMSG->(DBUNLOCK())
    ENDIF
  ENDIF

  // Set up EOF condition block
  bEof := { || VOICMSG->msg_id == oChannel:cUserMsgId .AND.;
               EMPTY(VOICMSG->deldate) }

  // Ensure next message meets play conditions
  IF VOICMSG->(oChannel:SkipRec(bEof))
    oChannel:aCurBlock := {{ || MsgInit() }, { || UserMsgProc() }}
  ELSE
    oChannel:aCurBlock := SeekMenuAct()
  ENDIF
ELSE
  LogInfo('UserMsgProc unexpected event:' + NTOC(nEvent))
  oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}
ENDIF

RETURN NIL

//
FUNCTION MenuInit()
// initialize for play of the menu-associated VOX file.
LOCAL cFile,;
      nHandle,;
      nRetVal

// set for any key termination
pd_global('termdtmf', '@')
oChannel:nTimeOut := 20

// Play the file for the appropriate menu option
cFile := oChannel:cMenuVOX

pd_dispMsg('Menu Init ' + cFile)

// Play the file
nRetVal := pd_play(nChan, cFile, @nHandle)
oChannel:nHandle := nHandle

RETURN nRetVal

//
FUNCTION MenuProc()
// Close the menu-associated VOX file and begin processing the menu function.

// Close the most recently played file
pd_VOXClose(oChannel:nHandle)

// File completion means get menu input
IF nEvent == T_EOF .OR. nEvent == T_TERMDT
  oChannel:aCurBlock := {{ || MenuInpInit() }, { || MenuInpProc() }}
ELSE
  LogInfo('MenuProc unexpected event:' + NTOC(nEvent))
  oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}
ENDIF

RETURN NIL

//
FUNCTION MenuInpInit()
// initialize for menu selection
LOCAL nRetVal

pd_dispMsg('Menu Input Init')

// set for # key termination
pd_global('termdtmf', '@')

nRetVal := pd_getDTMFs(nChan)

RETURN nRetVal

//
FUNCTION MenuInpProc()
// accept input for menu selection and process the option.
LOCAL cDtmfBuf,;
      nPos

pd_dispMsg('Menu Input Proc')

// Check for terminating dtmf
IF nEvent == T_TERMDT
  cDtmfBuf := pd_getBuf(nChan)
  IF cDtmfBuf == '#'
    oChannel:aCurBlock := {{ || GByeInit() }, { || GByeProc() }}
  ELSE
    cDtmfBuf := RemTermDtmf(cDtmfBuf)

    // see what key they pressed
    nPos := ASCAN(oChannel:aMenu, { |aEle| aEle:cTeleKey == cDtmfBuf })
    IF nPos > 0
      // a valid menu selection was made
      oChannel:nCurOption := nPos
      oChannel:aCurBlock  := SeekDictAct(oChannel:aMenu[nPos]:cNextAct)
    ELSE
      oChannel:aCurBlock  := {{ || InvalidInit() }, { || InvalidProc() }}
      oChannel:aNextBlock := {{ || MenuInit() }, { || MenuProc() }}
    ENDIF
  ENDIF
ELSE
  LogInfo('MenuInpProc unexpected event:' + NTOC(nEvent))
  oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}
ENDIF

RETURN NIL

//
FUNCTION DictInit()
// initialize entry for voicdict line item.
LOCAL cWhen,;
      nRetVal

pd_dispMsg('Dict Init')

// set for # key termination
pd_global('termdtmf', '#')

cWhen := ALLTRIM(VOICDICT->when)
IF EMPTY(cWhen)
   cWhen := '.T.'
ENDIF

// Execute the when function
nRetVal := EVAL(COMPILE(cWhen))

IF VALTYPE(nRetVal) <> 'N'
  nRetVal := pd_putEvent(nChan, T_APPEVT, 0)
ENDIF

RETURN nRetVal

//
FUNCTION DictProc()

LOCAL bEof              := { || VOICDICT->group_id == oChannel:cDictGroup }

pd_dispMsg('DictProc')

// Goto the current record for this channel
VOICDICT->(oChannel:GotoCurRec())

IF nEvent == T_EOF .OR. nEvent == T_TERMDT .OR. nEvent == T_APPEVT
  // Close the most recent file played
  pd_VOXClose(oChannel:nHandle)
  oChannel:nHandle := 0

  // Get dictionary record input
  DO CASE
    CASE VOICDICT->linetype == 'I'
      oChannel:aCurBlock := {{ || DictInpInit() }, { || DictInpProc() }}

  OTHERWISE
    oChannel:aCurBlock := dictLoopTest()
  ENDCASE
ELSE
  LogInfo('DictProc unrecognized event:' + NTOC(nEvent))
  oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}
ENDIF

RETURN NIL

//
FUNCTION DictInpInit()

LOCAL nRetVal

pd_dispMsg('Dict Input')

nRetVal := pd_getDTMFs(nChan)

RETURN nRetVal

//
FUNCTION DictInpProc()

LOCAL bEof := { || VOICDICT->group_id == oChannel:cDictGroup },;
      cBuf,;
      nDtmfBuf

pd_dispMsg('DictInpProc')

// Goto the current record for this channel
VOICDICT->(oChannel:GotoCurRec())

// Check for maximum dtmf
DO CASE
   CASE nEvent == T_TERMDT
     cBuf := pd_getBuf(nChan)
     DO CASE
        CASE RIGHT(cBuf, 3) == '**#'
           // the "clear" key.
           oChannel:aCurBlock := {{ || DictInit() }, { || DictProc() }}
           // oChannel:aCurBlock := DictLoopTest()

        CASE cBuf == '*#'
           // backup one
           IF oChannel:nRepeat > 1
              oChannel:nRepeat--
           ELSE
              VOICDICT->(oChannel:SkipRec(bEof, -1) )
           ENDIF
           oChannel:aCurBlock := {{ || DictInit() }, { || DictProc() }}

        CASE EMPTY(VOICDICT->valid)
          // no valid block
          nDtmfBuf := VAL(cBuf)

          IF (VOICDICT->low == 0        .AND. VOICDICT->high == 0) .OR.;
             (VOICDICT->low <= nDtmfBuf .AND. nDtmfBuf <= VOICDICT->high)
            // Echo telephone key entry
            oChannel:aCurBlock := {{ || EchoInit(GALLONS) }, { || EchoProc() }}

            // Determine if reached end of data set
            oChannel:aNextBlock := DictLoopTest()
          ELSE
            oChannel:aCurBlock  := {{ || InvalidInit() }, { || InvalidProc() }}
            oChannel:aNextBlock := {{ || DictInit() }, { || DictProc() }}
          ENDIF

      CASE EVAL(COMPILE(VOICDICT->valid))
       // Do nothing, called function sets the current and next block

     OTHERWISE
       // there was a valid but it returned .F.
       oChannel:aCurBlock  := {{ || InvalidInit() }, { || InvalidProc() }}
       oChannel:aNextBlock := {{ || DictInit() }, { || DictProc() }}
     ENDCASE

   CASE nEvent == T_TIME
      // they waited too long, repeat the prompt.
      oChannel:aCurBlock := {{ || DictInit() }, { || DictProc() }}

   OTHERWISE
      // it was not a terminating character event
      LogInfo('DictInpProc unexpected event:' + NTOC(nEvent))
      oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}
ENDCASE

RETURN NIL

//
FUNCTION SelectionInit()
// announce the selection made if its not empty
LOCAL cFile,;                                    // the file to be played
      nHandle,;                                  // the file's handle
      nRetVal

cFile := oChannel:aMenu[oChannel:nCurOption]:cVoxFile

pd_dispMsg('SelectionInit():' + cFile)

// Play the file
nRetVal := pd_play(nChan, cFile, @nHandle)
oChannel:nHandle := nHandle

RETURN nRetVal


//
FUNCTION SelectionProc()
// close the file for the selection made

// Close the most recently played file
pd_dispMsg('Close ' + oChannel:cMenuVox)
pd_VOXClose(oChannel:nHandle)

   // go next to date input.
   oChannel:aCurBlock := {{ || DateInit() }, { || DateProc() }}

RETURN NIL

//
FUNCTION DateInit()
// initialize entry for voicdict line item.
LOCAL dDefault          := DATE()-1,;            // default date to plug
      lCopyDate         := .F.,;                 // copy date from another dataset
      nHandle,;
      nRetVal

pd_dispMsg('Date Init ')

// set for # key termination
pd_global('termdtmf', '#')

SETAREA('VOICSHIF', 'VOICSHIF')

// find the correct record in voicshif.dbf
// voicshif.dbf determines parameters about the data entry group for this
// store.  How many shifts do they do (if any) and is this entry keyed
// to the date or not?

FindShift(oChannel:cLevel1 + oChannel:cDictGroup)

// set the channel object's temporary holder for shift entry flag, date entry flag.
oChannel:lShifts := VOICSHIF->shifts
oChannel:lDates  := VOICSHIF->dates

// find the correct record in voiclast.dbf
IF oChannel:lDates
   // the default date for this data set is not the last date entered +1,
   // but the last effective date entered for a different data set!
   IF .NOT. EMPTY(VOICSHIF->date_copid)
      VOICLAST->(DBSEEK( oChannel:cLevel1 + VOICSHIF->date_copid ))
      IF .NOT. VOICLAST->(FOUND())
        // protect against no record in the file
        VOICLAST->(DBAPPEND())
        REPLACE VOICLAST->location   WITH oChannel:cLevel1,;
                VOICLAST->last_date  WITH dDefault,;
                VOICLAST->group      WITH VOICSHIF->date_copid
      ENDIF
      dDefault  := VOICLAST->last_date - 1
      lCopyDate := .T.
   ENDIF

   // if this dictionary group is keyed to dates, play the current date
   // and let them change it.
   VOICLAST->(DBSEEK( oChannel:cLevel1 + oChannel:cDictGroup ))
   IF .NOT. VOICLAST->(FOUND())
     // protect against no record in the file
     VOICLAST->(DBAPPEND())
     REPLACE VOICLAST->location   WITH oChannel:cLevel1,;
             VOICLAST->last_date  WITH dDefault,;
             VOICLAST->group      WITH oChannel:cDictGroup
   ENDIF
   IF lCopyDate
      // if the default date is to be copied from another data set, make
      // sure it gets plugged in, even if a new record was not added to
      // voiclast.dbf
      REPLACE VOICLAST->last_date WITH dDefault
   ENDIF

   // set the channel's instance variables concerning the date
   oChannel:dCurrent  := VOICLAST->last_date
   oChannel:nShift    := VOICLAST->last_shift
   oChannel:nMaxShift := VOICSHIF->max_Shift

   // Play the file, tell 'em the date.
   nRetVal := PlayDate()
ELSE
   // place an application event to tell DateProc() we're not entering dates
   nRetVal := pd_putEvent(nChan, T_APPEVT, 0)
ENDIF

CLOSE VOICSHIF

RETURN nRetVal

//
FUNCTION DateProc()
// analyze the play of the date announcement done by dateInit() or PlayDate()
// Close the most recent file played
pd_dispMsg('Date Proc ')

DO CASE
   CASE nEvent == T_APPEVT
      // application event tells us that dates are not being entered.
      oChannel:nRepeat   := 1   // set initially
      oChannel:aCurBlock := {{ || DictInit() }, { || DictProc() }}

   CASE nEvent == T_EOF .OR. nEvent == T_TERMDT
       // normal end of date play message, get response to presented date
       oChannel:aCurBlock := {{ || DateInpInit() }, { || DateInpProc() }}

   OTHERWISE
      LogInfo('DictProc unrecognized event:' + NTOC(nEvent))
      oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}

ENDCASE

RETURN NIL

//
FUNCTION DateInpInit()
// set up for DTMF input in response to the date presented.
LOCAL nRetVal

pd_dispMsg('Date Input Init')

nRetVal := pd_getDTMFs(nChan)

RETURN nRetVal

//
FUNCTION DateInpProc()
// enter/select date for data entry group
// press '#' to accept the current date.
// press one to decrement the date/shift
// press two to advance the date/shift
// Any other key will repeat the previous date.
LOCAL cKey

pd_dispMsg('Date Input Process')

DO CASE
  CASE nEvent == T_EOF .OR. nEvent == T_TERMDT

    cKey := LEFT(pd_getBuf(nChan), 1)

    DO CASE
       CASE cKey == '1'   // decrement the date/shift
          DateDown(oChannel)

          oChannel:aCurBlock := {{ || PlayDate() }, { || DateProc() }}

       CASE cKey == '2'   // increment date/shift
          DateUp(oChannel)

          oChannel:aCurBlock := {{ || PlayDate() }, { || DateProc() }}

       CASE cKey == '*'
          // they picked the wrong menu option, go back to the menu
          oChannel:aCurBlock := {{ || MenuInit() }, { || MenuProc() }}

       CASE cKey == '#'
          // the entered date is OK, go on.

          oChannel:nRepeat   := 1
          oChannel:aCurBlock := {{ || DictInit() }, { || DictProc() }}
          IF oChannel:oFLocation <> NIL
             // if there is a fueling location already loaded for the
             // user, set the date in the fueling location to be
             // the new selected date.
             oChannel:oFlocation:dCurrent := oChannel:dCurrent
          ENDIF

       OTHERWISE
          // just play it again like it was.
          oChannel:aCurBlock := {{ || PlayDate() }, { || DateProc() }}

   ENDCASE


  OTHERWISE
    // unrecognized event
    LogInfo('DateProc unrecognized event:' + NTOC(nEvent))
    oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}

ENDCASE

RETURN NIL


//
FUNCTION DictLoopTest()

LOCAL bEof              := { || VOICDICT->group_id ==;
                                oChannel:cDictGroup },;
      aCurBlock

// Repeat count exceeded?
IF oChannel:nRepeat++ >= VOICDICT->repeat
  // Skip to the next VOICDICT record if repeat exceeded and not EOF
  IF VOICDICT->( oChannel:SkipRec(bEof) )
    oChannel:nRepeat := 1
    aCurBlock := {{ || DictInit() }, { || DictProc() }}
    oChannel:nTimeOut := VOICDICT->timeout
  ELSE
    // Determine if menu is available/required
    IF LEN(oChannel :aMenu) == 0
      aCurBlock := {{ || GByeInit() }, { || GByeProc() }}
    ELSE
      oChannel:nRepeat := 1  // ???
      aCurBlock := {{ || MenuInit() }, { || MenuProc() }}
    ENDIF
  ENDIF
ELSE
  // Repeat current VOICDICT record
  aCurBlock := {{ || DictInit() }, { || DictProc() }}
ENDIF

RETURN aCurBlock

//
FUNCTION GByeInit()

// Initiate function to handle playing the goodbye message.

LOCAL nHandle,;
      nRetVal

// Play the file for the appropriate security level
pd_dispMsg('Play ' + oChannel:cGByeVox)

// set for @ key termination
pd_global('termdtmf', '@')

// Play the file
nRetVal := pd_play(nChan, oChannel:cGByeVox, @nHandle)
oChannel:nHandle := nHandle

RETURN nRetVal

//
FUNCTION GByeProc()

// Process function to handle playing the goodbye message.

// Close the most recently played file
pd_dispMsg('Close ' + oChannel:cGByeVox)
pd_VOXClose(oChannel:nHandle)

// Put channel back on hook
oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}

RETURN NIL

//
FUNCTION InvalidInit()

// Initiate function for an invalid entry.

LOCAL nHandle,;
      nRetVal

// set for any key termination
pd_global('termdtmf', '@')

pd_dispMsg('Invalid')
nRetVal := pd_play(nChan, 'INVALID.VOX', @nHandle)
oChannel:nHandle := nHandle

RETURN nRetVal

//
FUNCTION InvalidProc()

// Process function to determine sucess of a sign on record.

// Close the most recent file played
pd_VOXClose(oChannel:nHandle)

// End of file, otherwise put line on hook
IF nEvent == T_EOF .OR. nEvent == T_TERMDT
  oChannel:aCurBlock := {{ || InvPlayInit() }, { || InvPlayProc() }}
ELSE
  LogInfo('InvalidProc Unexpected event:' + NTOC(nEvent))
  oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}
ENDIF

RETURN NIL

//
FUNCTION InvPlayInit()

// Initiate function for an invalid entry.

LOCAL cChar,;
      cDtmfBuf,;
      nHandle,;
      nIdx,;
      nLen,;
      nRetVal

pd_dispMsg('InvPlay')

cDtmfBuf := pd_getBuf(nChan)
cDtmfBuf := CHARREM('#', cDtmfBuf)
cDtmfBuf := ATREPL('*', cDtmfBuf, '.')

nRetVal := pd_playNum(nChan, VAL(cDTMFBuf), 'C')

RETURN nRetVal

//
FUNCTION InvPlayProc()

// Process function to determine sucess of a sign on record.

// Close the most recent file played
// pd_VOXClose(oChannel:nHandle)

// End of file, otherwise put line on hook
IF nEvent == T_EOF .OR. nEvent == T_TERMDT
  oChannel:aCurBlock := oChannel:aNextBlock
ELSE
  LogInfo('InvPlayProc unexpected event:' + NTOC(nEvent))
  oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}
ENDIF

RETURN NIL

//
FUNCTION EchoInit(cType)

// Initiate function for an invalid entry.

LOCAL cDtmfBuf,;
      nHandle,;
      nRetVal

DEFAULT cType TO 'D'

pd_dispMsg('EchoInit')

// set for @ key termination
pd_global('termdtmf', '@')

cDtmfBuf := pd_getBuf(nChan)

nRetVal := TalkAmt(cDtmfBuf, cType)

RETURN nRetVal

//
FUNCTION EchoProc()

// Process function to determine sucess of an echo playback.
pd_dispMsg('EchoProc')

// End of file, otherwise put line on hook
IF nEvent == T_EOF .OR. nEvent == T_TERMDT
  oChannel:aCurBlock := oChannel:aNextBlock
ELSE
  LogInfo('EchoProc unexpected event:' + NTOC(nEvent))
  oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}
ENDIF

RETURN NIL

//
FUNCTION GTotInit()
// initialize for play of grand total

LOCAL nHandle,;
      nRetVal

pd_dispMsg('GTotInit')

// set for no termination
pd_global('termdtmf', '')

nRetVal  := pd_play(nChan, 'GOODTOT.VOX', @nHandle)
oChannel:nHandle := nHandle

RETURN nRetVal

//
FUNCTION GTotProc()
// process play of grand total

pd_dispMsg('GTot Proc')

// Close the most recent file played
pd_VOXClose(oChannel:nHandle)

// End of file, otherwise put line on hook
IF nEvent == T_EOF .OR. nEvent == T_TERMDT
  oChannel:aCurBlock := oChannel:aNextBlock
ELSE
  LogInfo('GTotProc unexpected event:' + NTOC(nEvent))
  oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}
ENDIF

RETURN NIL

//
FUNCTION BTotInit()

LOCAL cDtmfBuf,;
      nHandle,;
      nRetVal

pd_dispMsg('BTotInit')

cDtmfBuf := pd_getBuf(nChan)
nRetVal := TalkAmt(cDtmfBuf, DOLLARS)

nRetVal := pd_play(nChan, 'TEMP.VOX', @nHandle)
oChannel:nHandle := nHandle

RETURN nRetVal

//
FUNCTION BTotProc()

// Process function to determine success of a sign on record.

// Close the most recent file played
pd_VOXClose(oChannel:nHandle)

// End of file, otherwise put line on hook
IF nEvent == T_EOF .OR. nEvent == T_TERMDT
  oChannel:aCurBlock := oChannel:aNextBlock
ELSE
  LogInfo('BTotProc unexpected event:' + NTOC(nEvent))
  oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}
ENDIF

RETURN NIL

////
FUNCTION SecLevel()
// returns true if an entry is found for the current attempt at logging on
LOCAL cDtmfBuf,;
      cSeekVal,;
      lFound           := .F.

// Get the dtmf buffer and remove terminating character
cDtmfBuf := PADR(RemTermDtmf(pd_getBuf(nChan)), LEN(VOICUSER->level1))

// Create the seek value based on the security level to lookup
DO CASE
  CASE oChannel:nGetSecLev == 1
    cSeekVal := cDtmfBuf

  CASE oChannel:nGetSecLev == 2
    cSeekVal := oChannel:cLevel1 + cDtmfBuf

  CASE oChannel:nGetSecLev == 3
    cSeekVal := oChannel:cLevel1 + oChannel:cLevel2 + cDtmfBuf
ENDCASE

// Lookup the security seek value
IF .NOT. EMPTY(cSeekVal)
  lFound := VOICUSER->(DBSEEK(cSeekVal, .F.))
ENDIF

IF lFound
  // Found a record for current security level
  DO CASE
    CASE oChannel:nGetSecLev == 1
      oChannel:cLevel1 := cDtmfBuf
      IF EMPTY(VOICUSER->voxfile2)
        oChannel:nGetSecLev := MMAXSECLEV + 1
      ELSE
        oChannel:cSecVox := VoxExt(VOICUSER->voxfile2)
        oChannel:nGetSecLev++
      ENDIF

    CASE oChannel:nGetSecLev == 2
      oChannel:cLevel2 := cDtmfBuf
      IF EMPTY(VOICUSER->voxfile3)
        oChannel:nGetSecLev := MMAXSECLEV + 1
      ELSE
        oChannel:cSecVox := VoxExt(VOICUSER->voxfile3)
        oChannel:nGetSecLev++
      ENDIF

    CASE oChannel:nGetSecLev == 3
      oChannel:cLevel3    := cDtmfBuf
      oChannel:nGetSecLev := MMAXSECLEV + 1
  ENDCASE
ELSE
  oChannel:nSecRetry++
ENDIF

RETURN lFound

////
STATIC FUNCTION GenMsg()

// Determines if any general messages need to be played.

LOCAL cSeekVal,;
      aCurBlock         := {}

pd_dispMsg('Seek GenMsg')

IF EMPTY(VOICUSER->genmsg_id)
  // Check for user messages
  aCurBlock := UserMsg()
ELSE
  // Create the seek value, the '1' means not a deleted record
  cSeekVal := VOICUSER->genmsg_id + '1'

  // Seek for a general message
  VOICMSG->(DBSEEK(cSeekVal, .F.))

  IF VOICMSG->msg_id == VOICUSER->genmsg_id .AND.;
     VOICMSG->sequence <= VOICUSER->genmsg_max
    // General message found
    oChannel:cGenMsgId  := VOICUSER->genmsg_id
    oChannel:nGenMsgMax := VOICUSER->genmsg_max
    oChannel:nRecNo     := VOICMSG->(RECNO())
    aCurBlock               := {{ || MsgInit() }, { || GenMsgProc() }}
  ELSE
    // Check for user messages
    aCurBlock := UserMsg()
  ENDIF
ENDIF

RETURN aCurBlock

////
STATIC FUNCTION UserMsg()

// Determines if any user messages need to be played.

LOCAL cSeekVal,;
      aCurBlock         := {}

pd_dispMsg('Seek UserMsg')

IF EMPTY(VOICUSER->usermsg_id)
  aCurBlock := SeekMenuAct()
ELSE
  // Create the seek value, the '1' means not a deleted record
  cSeekVal := VOICUSER->usermsg_id + '1'

  // Seek for a user message
  VOICMSG->(DBSEEK(cSeekVal, .F.))

  IF VOICMSG->msg_id == VOICUSER->usermsg_id .AND. EMPTY(VOICMSG->deldate)
    // User message found
    oChannel:cUserMsgId := VOICUSER->usermsg_id
    oChannel:nRecNo     := VOICMSG->(RECNO())
    aCurBlock               := {{ || MsgInit() }, { || UserMsgProc() }}
  ELSE
    aCurBlock := SeekMenuAct()
  ENDIF
ENDIF

RETURN aCurBlock

////
STATIC FUNCTION SeekMenuAct()
// Determines the next action after messages.  Returns a pair of code blocks
// of the next things to do.

LOCAL aCurBlock         := {}

pd_dispMsg('Seek next menu option')

IF EMPTY(VOICUSER->next_act)
  // there's nothing else to do.  Hang up.
  aCurBlock := {{ || GByeInit() }, { || GByeProc() }}
ELSE
  // do the user specific preproc.
  IF .NOT. EMPTY(VOICUSER->preproc)
     DOPROCS(VOICUSER->preproc)
  ENDIF

  // look for the next activity to do.
  VOICPRMP->(DBSEEK(VOICUSER->next_act, .F.))

  // set channel object's menu vox file instance variable to that in the
  // VOICMENU.DBF.  VOICMENU should be positioned by the relation.
  oChannel:cMenuVox := VoxExt(VOICMENU->voxfile)

  // it may be a menu, or it may be a voicdict dataset.
  DO WHILE VOICPRMP->menu_id == VOICUSER->next_act
    AADD(oChannel:aMenu,;
         Menu():New(VOICPRMP->next_act, VOICPRMP->tele_key,;
                    VoxExt(VOICPRMP->voxfile)))

    // Read the next VOICPRMP record
    VOICPRMP->(DBSKIP())
  ENDDO

  IF LEN(oChannel:aMenu) == 0
    aCurBlock := SeekDictAct(VOICUSER->next_act)
  ELSE
    aCurBlock := {{ || MenuInit() }, { || MenuProc() }}
  ENDIF
ENDIF

RETURN aCurBlock

////
FUNCTION LoadMenu(cMenu)
// Determines the next action after messages.  Returns a pair of code blocks
// of the next things to do.
LOCAL nRetVal

pd_dispMsg('Load next menu option')

DEFAULT cMenu TO ''
cMenu := ALLTRIM(UPPER(cMenu))

IF EMPTY(cMenu)
    LogInfo('Menu requested cannot be blank.')
    oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}

ELSE
   VOICPRMP->( DBSEEK(cMenu, .F.) )
   DO WHILE VOICPRMP->menu_id == PADR(cMenu, 8)
      AADD(oChannel:aMenu,;
           Menu():New(VOICPRMP->next_act, VOICPRMP->tele_key,;
                      VoxExt(VOICPRMP->voxfile)))

      // Read the next VOICPRMP record
      VOICPRMP->(DBSKIP())
   ENDDO

   IF LEN(oChannel:aMenu) == 0
      LogInfo('Menu ' + cMenu + ' not found.')
      oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}
   ENDIF
ENDIF

nRetVal := pd_putEvent(nChan, T_APPEVT, 0)

RETURN nRetVal

////
STATIC FUNCTION SeekShift()

pd_dispMsg('Seek Shift')

RETURN {{ || OnHookInit() }, { || OnHookProc() }}

////
STATIC FUNCTION SeekDictAct(cAction)
// finds the next dataset to process in voicdict.dbf

LOCAL aCurBlock                                  // the next set of blocks to execute

pd_dispMsg('Seek DictAct')

IF VOICDICT->(DBSEEK(cAction, .F.))
  // the group to process was found.
  oChannel:cDictGroup := VOICDICT->group_id
  oChannel:nRecNo     := VOICDICT->(RECNO())
  aCurBlock           := {{ || SelectionInit() },  { || SelectionProc() }}

ELSE
  LogInfo('Group ' + cAction + ' to process not found.')
  aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}
ENDIF

RETURN aCurBlock 

////
STATIC FUNCTION FldSize(cField)

// Determines the size of a DBF field.

LOCAL nPos,;
      nSize

// Determine if field exists
nPos := FIELDPOS(cField)
IF nPos == 0
  // Field does not exist
  nSize := 0
ELSE
  // Use the field number to determine the field size
  nSize := FIELDSIZE(nPos)
ENDIF

RETURN nSize

////
STATIC FUNCTION RemTermDtmf(cDtmfBuf)

// Removes the terminating character from the dtmf buffer.

// Ensure rightmost character is terminating character
IF RIGHT(cDtmfBuf, 1) == MTERMDTMF
  cDtmfBuf := LEFT(cDtmfBuf, LEN(cDtmfBuf) - 1)
ENDIF

RETURN cDtmfBuf

////
STATIC FUNCTION VoxExt(cVoxFile)

// Checks to determine if VOX extension needs to be added to file name.

// Trim leading and trailing spaces
cVoxFile := ALLTRIM(cVoxFile)

// Check for presence of '.', add '.VOX' extension if not present
cVoxFile := IIF('.' $ cVoxFile, cVoxFile, cVoxFile + '.VOX')

RETURN cVoxFile

////
STATIC FUNCTION TalkAmt(cDtmfBuf, cType)
// say the amount preceded by the echo prompt e.g. "You Entered"
LOCAL nRetVal,;                                  // the return value
      nValue,;                                   // value of the number
      aSeq              := {}                    // sequence array

DEFAULT cType TO 'D'

IF cDtmfBuf == '#'
  // pound sign
  AADD(aSeq, {{pd_handGlobal(), 405}} )
  nRetVal := pd_playSeq(nChan, aSeq)
ELSE
  cDtmfBuf := RemTermDtmf(cDtmfBuf)
  cDtmfBuf := ATREPL('*', cDtmfBuf, '.')
  nValue   := VAL(cDtmfBuf)
  nRetVal := pd_playNum(nChan, nValue, cType)
ENDIF

RETURN nRetVal

//
FUNCTION GasStick()
// analyze entered stick reading
LOCAL cBuffer,;
      lValid           := .T.,;
      nDepth,;
      nVolume,;
      oTank

pd_dispMsg('GasStick')

// Get the most recent stick reading
cBuffer := remTermDTMF( pd_getBuf(nChan) )

// Get the tank object
oTank := oChannel:oFlocation:GetTank( oChannel:nRepeat )

IF oTank <> NIL
   IF oChannel:oFLocation:lEntInch
	  // stick readings are to be entered in inches

	  IF oChannel:oFLocation:lEntFrac
		 // stick readings are entered as fractions
         IF NUMTOKEN(cBuffer, '*') < 3

			// the person only entered the numerator of the fraction.
            // default the denominator of the fraction to the object instance
            // variable which comes from the system parameter for the store.
			nDepth := VAL(TOKEN(cBuffer, '*', 1)) + VAL(TOKEN(cBuffer, '*', 2)) / oChannel:oFlocation:nDenominator
		 ELSE
			// they entered both numerator and denominator
			nDepth := VAL(TOKEN(cBuffer, '*', 1)) + VAL(TOKEN(cBuffer, '*', 2)) / VAL(TOKEN(cBuffer, '*', 3))
		 ENDIF
	  ELSE
		 // stick readings are entered as decimal inches
         nDepth := VAL(ATREPL('*', cBuffer, '.'))
	  ENDIF
      oTank:GetStick():nGasDepth := nDepth

      lValid := ChartLookUp(oTank, nDepth, @nVolume)
   
   ELSE
	  // stick readings are entered as gallons
	  nVolume := VAL(ATREPL('*', cBuffer, '.'))
      oTank:getStick():nGasDepth := 0
   ENDIF

   IF lValid
      // Put the volume in the C dtmf buffer for play back
      pd_putBuf(nChan, NTOC(nVolume))
   ELSE
      // invalid entry, put in the origial buffer for Invalid()
      pd_putBuf(nChan, cBuffer)
   ENDIF

   // same for volume entry or depth entry
   oTank:GetStick():nGasVolume := nVolume

   pd_dispMsg('Depth:' + ALLTRIM(STR( oTank:getStick():nGasDepth)) + ;
               ' Vol:' + ALLTRIM(STR( oTank:getStick():nGasVolume)) )

   // Echo telephone key entry
   oChannel:aCurBlock := {{ || EchoInit(GALLONS) }, { || EchoProc() }}

   IF oChannel:nRepeat >= oChannel:oFlocation:nTankCount
	  // if the current repeat is higher than the number of tanks we have,
	  // set it to the maximum so we can go on.
	  oChannel:nRepeat := VOICDICT->repeat+1
   ENDIF

   // Determine if reached end of file
   IF lValid
      oChannel:aNextBlock := DictLoopTest()
   ENDIF
ELSE
   // tank object was invalid
   LogInfo('Tank object invalid!')
   oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}

ENDIF

RETURN lValid

//
FUNCTION UpdateSales()

// Updates the sales total.

LOCAL bEof,;
      cSales,;
      nSales

// Setup EOF condition block
bEof := { || VOICDICT->group_id == oChannel:cDictGroup }

cSales := pd_getBuf(nChan)
cSales := ATREPL('*', cSales, '.')
nSales := VAL(cSales)

IF VOICDICT->(RECLOCK())
  // !!! Need to position to correct voicuser record
  REPLACE VOICUSER->sales WITH VOICUSER->sales + nSales
  UNLOCK
ENDIF

// Determine if reached end of file
IF VOICDICT->(oChannel:SkipRec(bEof))
  oChannel:aCurBlock := {{ || DictInit() }, { || DictProc() }}
ELSE
  // Determine if menu is available
  IF LEN(oChannel:aMenu) == 0
    oChannel:aCurBlock := {{ || GByeInit() }, { || GByeProc() }}
  ELSE
    oChannel:aCurBlock := {{ || MenuInit() }, { || MenuProc() }}
  ENDIF
ENDIF

RETURN .T.

//
FUNCTION TotalSales()

// Updates the sales total.

LOCAL bEof,;
      cAmt,;
      cSales,;
      nSales

// Setup EOF condition block
bEof := { || VOICDICT->group_id == oChannel:cDictGroup }

// Get the entered total sales
cSales := pd_getBuf(nChan)
cSales := ATREPL('*', cSales, '.')
nSales := VAL(cSales)

// Compare entered total sales to total of all departments
IF nSales == VOICUSER->sales  // !!! Need to position to correct voicuser record
  // Echo telephone key entry
  oChannel:aCurBlock := {{ || GTotInit(), GTotProc() }}
ELSE
  oChannel:aCurBlock := {{ || BTotInit(), BTotProc() }}
ENDIF

// Determine if reached end of file
IF VOICDICT->(oChannel:SkipRec(bEof))
  oChannel:aNextBlock := {{ || DictInit() }, { || DictProc() }}
ELSE
  // Determine if menu is available
  IF LEN(oChannel:aMenu) == 0
    oChannel:aNextBlock := {{ || GByeInit() }, { || GByeProc() }}
  ELSE
    IF nSales == VOICUSER->sales
      oChannel:aNextBlock := {{ || MenuInit() }, { || MenuProc() }}
    ELSE
      // !!! For NACS
      VOICDICT->(DBSEEK('SALES', .F.))
      oChannel:nRecNo     := VOICDICT->(RECNO())
      // changed the following line ???  was two function calls, one code block.
      // did not seem right.
      oChannel:aNextBlock := {{ || DictInit() }, {|| DictProc() }}
    ENDIF
  ENDIF
ENDIF

IF VOICDICT->(RECLOCK())
  // !!! Need to position to correct voicuser record
  cAmt := LTRIM(STR(VOICUSER->sales))
  REPLACE VOICUSER->sales WITH 0
  UNLOCK
ENDIF

RETURN .T.

////
STATIC FUNCTION pd_DispMsg(pMsg)

// Scrolls messages for a channel.

STATIC nEchoRow         := 0

IF VALTYPE(pMsg) == 'L'
  nEchoRow := 0
ELSE
  IF VALTYPE(pMsg) <> 'C'
    pMsg := ' '
  ENDIF

  // Scroll the screen if at bottom
  IF nEchoRow == MAXROW() - 2
    SCROLL(1, 1, 22, 21, 1)
  ELSE
    nEchoRow++
  ENDIF

  // Echo the message
  @nEchoRow, 1 SAY PadSpace(pMsg, 40)
ENDIF

RETURN NIL

////
FUNCTION Startup(cDOSParms)
// Initialize CLIPPER portion of voice system when executed as standalone
// program.
LOCAL cOvlDir

DEFAULT cDOSParms TO ''

SYSVAR(SYS_DOSPARMS, cDOSParms)                             // DOS parameters

IF UPPER(LEFT(cDosParms, 1)) == 'D'
   IF ISDEBUG()
      SYSVAR(SYS_TESTMODE,.T.)
   ENDIF

ELSEIF UPPER(LEFT(cDosParms, 1)) == 'H'
   // if the h parameter is passed, help pop-ups in edit mode.
   SYSVAR(SYS_EDITMODE,.T.)

ELSEIF UPPER(LEFT(cDosParms, 1)) == 'M'
   SYSVAR(SYS_MENUMODE,.T.)
ENDIF



SETBLINK(.F.)

// dummy for OASIS objects.
PUBLIC dtlast := DATE()

// Ensure that ENTER has to pressed after all gets.
SET CONFIRM ON

// Set system colors
LOADCOLORS()

// Create stacks and initialize system variables
INITSTACKS()

SYSVAR(SYS_ROOTPROG, ROOT_PROG())          // name of the executable
SYSVAR(SYS_MENFILE, 'MENUSPAL')
SYSVAR(SYS_PRMFILE, 'MOPTSPAL')

OpenSysDBF()

// dummy channel for loading system parameters (these are statics)
AADD(aChan, channel():new('','','',{ {|| NIL}, {|| NIL} }))
nChan := 1
oChannel:cLevel1 := PADR('9999', 10)


SYSVAR(SYS_STORE, GET_PM(9))               // store that we belong to (numeric)
SYSVAR(SYS_STSTR, LTRIM(STR(SYSVAR(SYS_STORE)))) // store that we belong to (string)
SYSVAR(SYS_TERR,  LTRIM(STR(GET_PM(8))))   // territory that we belong to
SYSVAR(SYS_YNDFLT, GET_PM(13))             // defaults allowed on yes/no
cOvlDir := ALLTRIM(GET_PM(22))             // Overlay directory
IF .NOT. EMPTY(cOvlDir)
  SYSVAR(SYS_OVLDIR, cOvlDir)
ENDIF

// Set system variables based on system parameters
SYSVAR(SYS_GENBOXCHR, cx_FRAME(GET_PM(36)) + ' ') // generic box characters
SYSVAR(SYS_PFIELDATT, GET_PM(37))                 // playing field attribute
SYSVAR(SYS_PFIELDCHR, GET_PM(38))                 // playing field character
SYSVAR(SYS_CLRTOFLD,  GET_PM(39))                 // clear to playing field?
SYSVAR(SYS_LOGCALLS,  GET_PM(40))                 // procedure/function logging
SYSVAR(SYS_WINDATT,   GET_PM(35))                 // window shadow attribute
SYSVAR(SYS_CLOCK,     GET_PM(6))                  // clock on screen

// Set Clipper Tools
SETCLEARA(SYSVAR(SYS_PFIELDATT))                  // playing field color
SETCLEARB(SYSVAR(SYS_PFIELDCHR))                  // playing field character
WSETSHADOW(SYSVAR(SYS_WINDATT))                   // standard shadow attribute
SETBOXGROW(GET_PM(49))                            // set box explosion time
SET(_SET_DATEFORMAT, GET_PM(55))                  // set date format for system

RETURN NIL

//
FUNCTION PlayPrompt(cFile)

// Initiate function to handle playing a prompt.

LOCAL nHandle,;
      nRetVal

pd_dispMsg('Play prompt')

// Add vox extension if needed
cFile := VoxExt(cFile)

// Play the file
nRetVal := pd_play(nChan, cFile, @nHandle)
oChannel:nHandle := nHandle

RETURN nRetVal

////
FUNCTION PlayTank(cType)
// Initiate function to handle playing a tank number prompt.

LOCAL cFile,;
      nHandle           := pd_handGlobal(),;     // file handle of global.vap
      nRetVal,;
      oTank,;
      aSeq              := {}

DEFAULT cType TO ''

cType := UPPER(LEFT(cType, 1))

oTank := oChannel:oFlocation:getTank( oChannel:nRepeat )

IF oTank <> NIL
   pd_dispMsg('Play tank #' + NTOC(oTank:nTank) )
   pd_dispMsg('Play tank seq#' + NTOC(oTank:nNameIdx) )

   // number
   AADD(aSeq, {nHandle, 407})

   // the number itself
   AADD(aSeq, {nHandle, oTank:nTank})

   // the tank's grade description index
   AADD(aSeq, {nHandle, oTank:nNameIdx} )

   // more verbose version
   DO CASE
      CASE cType == 'D'
         // delivery prompt
         AADD(aSeq, {nHandle, 415})

      CASE cType == 'G'
         // gallons entry
         AADD(aSeq, 413)

      CASE cType == 'M'
         // money (dollars)
         AADD(aSeq, 414)

      CASE cType == 'P'
         // price entry
         AADD(aSeq, 416)

      CASE cType == 'S'
         // stick reading prompt
         AADD(aSeq, {nHandle, 409})

      CASE cType == 'V'
         // volume prompt
         AADD(aSeq, {nHandle, 413})

      OTHERWISE
         // unknown type
         AADD(aSeq, {nHandle, 420})

   ENDCASE

   // tank number again
   AADD(aSeq, {nHandle, oTank:nTank})

   // grade description again
   AADD(aSeq, {nHandle, oTank:nNameIdx} )

   // Play the file
   nRetVal := pd_playSeq(nChan, aSeq)
   oChannel:nHandle := 0
ELSE
   nRetVal := pd_putEvent(nChan, T_APPEVT, 0)
ENDIF

RETURN nRetVal

////
FUNCTION PlayGrade(cType)
// Initiate function to handle playing a tank number prompt.

LOCAL cFile,;
      nHandle           := pd_handGlobal(),;     // file handle of global.vap
      nRetVal,;
      oGrade,;
      aSeq              := {}

DEFAULT cType TO ''

cType := UPPER(LEFT(cType, 1))

oGrade := oChannel:oFlocation:getGrade( oChannel:nRepeat )

IF oGrade <> NIL
   pd_dispMsg('Play grade #' + NTOC(oGrade:nGrade) )
   pd_dispMsg('Play grade seq#' + NTOC(oGrade:nNameIdx) )

   // "number"
   AADD(aSeq, {nHandle, 407})

   // the number itself
   AADD(aSeq, {nHandle, oGrade:nGrade})

   // the grade's grade description index
   AADD(aSeq, {nHandle, oGrade:nNameIdx} )

   // more verbose version
   DO CASE
      CASE cType == 'M'
         // money (dollars)
         AADD(aSeq, {nHandle, 424} )

      CASE cType == 'P'
         // price entry
         AADD(aSeq, {nHandle, 426} )

      CASE cType == 'V'
         // volume prompt
         AADD(aSeq, {nHandle, 423} )

      OTHERWISE
         // unknown type
         AADD(aSeq, {nHandle, 420} )

   ENDCASE

   // tank number again
   AADD(aSeq, {nHandle, oGrade:nGrade} )

   // grade description again
   AADD(aSeq, {nHandle, oGrade:nNameIdx} )

   // Play the file
   nRetVal := pd_playSeq(nChan, aSeq)
   oChannel:nHandle := 0
ELSE
   nRetVal := pd_putEvent(nChan, T_APPEVT, 0)
ENDIF

RETURN nRetVal


////
FUNCTION FuelPos()
// load fueling position information.  We can't load anything date sensitive
// in here, because the proper date has not been established for the data
// being entered.
LOCAL nHandle,;
      nRetVal,;
      oFL               := oChannel:oFlocation

SYSPLSWT2("Loading Tank Information")

// open tank charts file
SETAREA('CHARTS', 'CHARTS', .F.)

// add a pointer to a host fueling location object
oFL            := HostFLoc():New()
oFL:cStore     := LEFT(oChannel:cLevel1, 5)
oFL:cTerritory := oChannel:cTerritory
oFL:dCurrent   := oChannel:dCurrent

oFL:LoadTanks()              // load tank objects
oFL:LoadGrades()             // load grade objects
oFL:InitMeters()             // initialize meter objects
oFL:LoadHistory()            // load history data

IF .NOT. oFL:validate()      // validate whats there
   oFL:destroy()
   CLOSE CHARTS
   RETURN NIL  //  <Early return!!!!
ENDIF

// store a pointer to the fueling location in the channel object
oChannel:oFlocation := OFL

CLR_PLSWT2()

RETURN nRetVal

//
FUNCTION SaveStick()
// when save stick readings
LOCAL nRetVal

pd_DispMsg('SaveStick()')

oChannel:oFlocation:saveSticks()

nRetVal := pd_putEvent(nChan, T_APPEVT, 0)

RETURN nRetVal

//
FUNCTION GET_PM(nParameter)
// return system parameter value for store for this channel
LOCAL pRetVal           := '',;
      cParmType

PARMS->(DBSEEK( oChannel:cLevel1 + STR(nParameter, 6) ) )
cParmType := UPPER(PARMS->pm_type)

IF PARMS->(FOUND())
   DO CASE
      CASE cParmType == 'L'
         pRetVal := PARMS->pm_logical

      CASE cParmType == 'C'
         pRetVal := LEFT(PARMS->pm_char, PARMS->pm_len)

      CASE cParmType == 'N'
         pRetVal := ROUND(PARMS->pm_numeric, PARMS->pm_dec)

      CASE cParmType == 'D'
         pRetVal := PARMS->pm_date

      OTHERWISE
         GOOFED('Invalid pm_type ' + cParmType + ' Parameter #' + NTOC(nParameter))

   ENDCASE
ELSE
   GOOFED('Parameter #' + NTOC(nParameter) + ' not found!')
ENDIF


RETURN pRetVal

//
FUNCTION PlayDate()

// Play the date prompt
// play the date as numbers and day-of-week
// play the options to change the date.

LOCAL dDate             := oChannel:dCurrent,;
      nHandle,;
      nRetVal,;
      aSegs             := {}                    // array of segments to play

pd_dispMsg('Play date ' + DTOC(dDate) )

nHandle := pd_handGlobal()

// "the current day is"
AADD(aSegs, {nHandle, 401})

// "Monday" etc.
AADD(aSegs, {nHandle, 100+DOW(dDate)})

// "January" etc.
AADD(aSegs, {nHandle, 200+MONTH(dDate) })

// "first, etc."
AADD(aSegs, {nHandle, 300+DAY(dDate) })

// play shift number too. ////////////////////////////////////////////

// add the prompt, # to accept, 1 to backup, two to advance
AADD(aSegs, {nHandle, 402} )

nRetVal := pd_playSeq(nChan, aSegs)

// set the channel object's instance variable to the file handle to close
// later.

RETURN nRetVal

//
FUNCTION LogInfo(cMessage)

DEFAULT cMessage TO PROCNAME(1) + ' unexpected event'

// log_error() can be found in sysprocs.
pd_DispMsg(cMessage)

Log_error(cMessage + ' on channel ' + NTOC(nChan) + ;
         ' User:' + oChannel:cLevel1 + ' Date:' + DTOC(oChannel:dCurrent) + ;
         ' Shift:' + NTOC(oChannel:nShift) + CRLF)

RETURN NIL

//
FUNCTION BumpDate()
// increment the date number for the current data set in voiclast.dbf
LOCAL nRetVal

pd_DispMsg('Bump Date')

VOICLAST->(DBSEEK( oChannel:cLevel1 + oChannel:cDictGroup ))

DateUp(oChannel)

IF VOICLAST->(RecLock(STDWAIT))
   REPLACE VOICLAST->last_date  WITH oChannel:dCurrent,;
           VOICLAST->last_Shift WITH oChannel:nShift
   VOICLAST->(DBUNLOCK())
ENDIF

nRetVal := pd_putEvent(nChan, T_APPEVT, 0)

RETURN nRetVal

//
STATIC FUNCTION DateDown(oChan)
// decrement the channel's date

IF oChan:lShifts
   IF oChan:nShift > 0
       oChan:nShift--
   ELSE
      oChan:nShift := oChan:nMaxShift
      oChan:dCurrent--
   ENDIF
ELSE
   // no shifts involved
   oChan:dCurrent--

ENDIF

RETURN NIL

//
STATIC FUNCTION DateUp(oChan)
// increment the channel's date

IF oChan:lShifts
   IF oChan:nShift < oChan:nMaxShifts
      oChan:nShift++
   ELSE
      oChan:nShift := 1
      oChan:dCurrent++
   ENDIF
ELSE
   oChan:dCurrent++
ENDIF

RETURN NIL

//
FUNCTION DelivTank()
// when function to prompt for tank number input.
LOCAL nRetVal

pd_DispMsg('DelivTank')

// Enter tank number for delivery, or press pound to review your tanks
nRetVal := pd_playSeq(nChan, {{pd_handGlobal(), 410}} )

RETURN nRetVal

//
FUNCTION DTankValid()
// see if the entered tank number is valid
LOCAL cDTMF,;
      lRetVal           := .T.,;
      oTank

pd_DispMsg('DTankValid')

// Get the response to the tank number input prompt.
cDTMF := pd_getBuf(nChan)
DO CASE
   CASE cDTMF == '#'
      // review store's tanks
      oChannel:aCurBlock := { {|| ReviewTanks()}, {|| ReviewProc()} }

   CASE cDTMF == '0#'
      // they want out
      // Determine if menu is available/required
      IF LEN(oChannel:aMenu) == 0
        oChannel:aCurBlock := {{ || GByeInit() }, { || GByeProc() }}
      ELSE
        oChannel:nRepeat := 1
        oChannel:aCurBlock := {{ || MenuInit() }, { || MenuProc() }}
      ENDIF

   OTHERWISE
      oChannel:nTank := VAL(cDTMF)
      IF (oTank := oChannel:oFLocation:getTank(oChannel:nTank) ) <> NIL
         // it is a valid tank.  say the grade name.


         oChannel:aCurBlock  := {{ || TankNameInit(oTank) }, { || EchoProc() }}
         oChannel:aNextBlock := DictLoopTest()
      ELSE
         // its not a valid tank, go back and try again.
         lRetVal := .F.
      ENDIF
ENDCASE

RETURN lRetVal

//
FUNCTION ReviewTanks()
// review the store's tanks
LOCAL nHandle           := pd_handGlobal(),;     // file handle of global.vap
      nRetVal,;
      nTank,;
      aSeq              := {}

pd_DispMsg('ReviewTanks')

// your tanks are:
AADD(aSeq, {nHandle, 412})

FOR nTank := 1 TO oChannel:oFlocation:nTankCount
   // tank number
   AADD(aSeq, {nHandle, oChannel:oFlocation:getTank(nTank):nTank })

   // tank grade
   AADD(aSeq, {nHandle, oChannel:oFlocation:getTank(nTank):nNameIdx})
NEXT

nRetVal := pd_playSeq(nChan, aSeq)

RETURN nRetVal

//
FUNCTION ReviewProc()
// process function for review of tanks, go back to input

IF nEvent == T_EOF .OR. nEvent == T_TERMDT
   oChannel:aCurBlock := {{ || DictInit() }, { || DictProc() }}
ELSE
   LogInfo('ReviewProc unrecognized event:' + NTOC(nEvent))
   oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}
ENDIF

RETURN NIL

//
FUNCTION GasDeliv()
// valid function for entered gas delivery.  Make sure its not more than
// the tank capacity.

LOCAL cVolume,;
      lRetVal           := .T.,;
      nVolume,;
      oDelivery,;
      oTank

cVolume := pd_getBuf(nChan)

pd_DispMsg('GasDeliv')

// nTank stored by DTankValid()

oTank := oChannel:oFlocation:getTank( oChannel:nRepeat )
IF oTank <> NIL
   // should see if the delivery exists first
   IF (oDelivery := oChannel:oFlocation:getDelivery( oTank:nTank )) == NIL
      oDelivery := DelObj():New(oChannel:oFLocation, oTank:nTank)
      oChannel:oFlocation:AddDelivery(oDelivery)
   ENDIF

   cVolume := ATREPL('*', cVolume, '.')
   nVolume := VAL(cVolume)

   oDelivery:dDate       := oChannel:oFlocation:dCurrent         // delivery date
   oDelivery:nTank       := oTank:nTank                          // tank number
   oDelivery:nDelivery   := oChannel:oFlocation:nLastDelivery    // delivery number
   oDelivery:nSequence   := 1                                    // sequence number
   oDelivery:nNetGallons := nVolume                              // net gallons delivered (temp corrected)
   oDelivery:nGrsGallons := nVolume                              // gross gallons delivered (non temp-corrected)

   ++oChannel:oFlocation:nLastDelivery

   // Put the volume in the C dtmf buffer for play back
    pd_putBuf(nChan, NTOC(nVolume))

   // Echo telephone key entry
   oChannel:aCurBlock := {{ || EchoInit(GALLONS) }, { || EchoProc() }}

   IF oChannel:nRepeat >= oChannel:oFlocation:nTankCount
	  // if the current repeat is higher than the number of tanks we have,
	  // set it to the maximum so we can go on.
	  oChannel:nRepeat := VOICDICT->repeat+1
   ENDIF

   // Determine if reached end of file
   oChannel:aNextBlock := DictLoopTest()
ELSE
   // tank object not found
   LogInfo('GasDeliv() tank object invalid.')
   oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}

ENDIF

RETURN lRetVal

//
FUNCTION TankNameInit(oTank)
// play the tank name entered
LOCAL nHandle           := pd_handGlobal(),;
      nRetVal,;
      aSeq              := {}

pd_DispMsg('TankNameInit')

// number
AADD(aSeq, {nHandle, 407})

// the number itself
AADD(aSeq, {nHandle, oTank:nTank})

// the tank's grade description index
AADD(aSeq, {nHandle, oTank:nNameIdx} )

nRetVal := pd_playSeq(nChan, aSeq)

RETURN nRetVal

//
FUNCTION SaveDeliv()
// when function to save delivery information to the databases
LOCAL nRetVal

pd_DispMsg('SaveDeliv')

oChannel:oFlocation:saveDeliveries()

nRetVal := pd_putEvent(nChan, T_APPEVT, 0)

RETURN nRetVal

//
STATIC FUNCTION FindShift(cKey)
// find the voicshif.dbf record for a particular data set.  Add if it is not
// there.
VOICSHIF->(DBSEEK( cKey ))
IF .NOT. VOICSHIF->(FOUND())
   // add a record if no record found, defaults to date entry but no
   // shift entry.
   VOICSHIF->(DBAPPEND())
   REPLACE VOICSHIF->location WITH LEFT(cKey, 10),;
           VOICSHIF->group    WITH SUBSTR(cKey, 11, 8),;
           VOICSHIF->dates    WITH .T.
   VOICSHIF->(DBUNLOCK())
ENDIF

RETURN NIL

//
STATIC FUNCTION ChartLookUp(oTank, nDepth, nVolume)
// look up the entered inches in the tank chart
LOCAL lValid,;									 // entered amount valid?
	  nHighDepth,;								 // high side depth
	  nHighVol,;								 // high side volume
	  nLowDepth,;								 // low side depth
	  nLowVol									 // low side volume


// Seek for the entered stick reading
CHARTS->(DBSEEK(STR(oTank:nChartNumber, 2) + STR(nDepth, 7, 3), .T.))
IF CHARTS->(EOF()) .OR. oTank:nChartNumber <> CHARTS->chart
  // Invalid stick reading
  nVolume   := 0
  lValid    := .F.
ELSE
  lValid	:= .T.
  nHighVol	 := CHARTS->volume
  nHighDepth := CHARTS->depth
  CHARTS->(DBSKIP(-1))
  IF CHARTS->chart <> oTank:nChartNumber .OR. CHARTS->(BOF())
	nLowVol   := 0
	nLowDepth := 0
  ELSE
	nLowVol   := CHARTS->volume
	nLowDepth := CHARTS->depth
  ENDIF

  IF nHighDepth == nLowDepth
	nVolume := nLowVol
  ELSE
	// Interpolate
	nVolume := (nDepth - nLowDepth) / (nHighDepth - nLowDepth) *;
			   (nHighVol - nLowVol) + nLowVol
  ENDIF

ENDIF

RETURN lValid

//
FUNCTION PalError(oError)

// In front of error system to re-set the store number for parameters used
// by the error system.

// dummy channel for loading system parameters (these are statics)
AADD(aChan, channel():new('','','',{ {|| NIL}, {|| NIL} }))
nChan := 1
oChannel:cLevel1 := PADR('9999', 10)

RETURN pd_OError(oError)

//
FUNCTION GasPrice()
// analyze entered gas volume
LOCAL cBuffer,;
      lRetVal           := .T.,;
      nPrice,;                                   // gas price entered
      oMeter

pd_dispMsg('GasPrice')

// Get the most recent stick reading
cBuffer := remTermDTMF( pd_getBuf(nChan) )

// Get the meter object
oMeter := oChannel:oFlocation:GetMeter( oChannel:nRepeat )

IF oMeter <> NIL
   nPrice := VAL( ATREPL('*', cBuffer, '.') )

   IF nPrice > 10
      // if they did not put in a decimal point, put one in by dividing
      nPrice := nPrice /1000
   ENDIF

   // store the entered price in the grade object.
   oMeter:nEndPrice := nPrice

   // Put the volume in the C dtmf buffer for play back
   //
   pd_putBuf( nChan, ALLTRIM(STR(nPrice, 8, 3)) )

   // Echo telephone key entry
   oChannel:aCurBlock := {{ || EchoInit(DIGITS) }, { || EchoProc() }}

   IF oChannel:nRepeat >= oChannel:oFlocation:nGradeCount
      // if the current repeat is higher than the number of grades we have,
      // set it to the maximum so we can go on.
      oChannel:nRepeat := VOICDICT->repeat+1
   ENDIF

   // Determine if reached end of file
   oChannel:aNextBlock := DictLoopTest()

ELSE
   // grade object was invalid
   LogInfo('Meter object invalid!')
   oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}

ENDIF

RETURN lRetVal

//
FUNCTION GasVolume()
// analyze entered gas volume
LOCAL cBuffer,;
	  lRetVal			:= .T.,;
      nVolume,;
      oMeter

pd_dispMsg('GasVolume')

// Get the most recent gas volume
cBuffer := remTermDTMF( pd_getBuf(nChan) )

// Get the grade object
oMeter := oChannel:oFlocation:GetMeter( oChannel:nRepeat )

IF oMeter <> NIL
   cBuffer := ATREPL('*', cBuffer, '.')
   IF .NOT. '.' $ cBuffer
      nVolume := VAL(cBuffer) / 100
   ELSE
      nVolume := VAL(cBuffer)
   ENDIF

   // store in the grade object
   oMeter:nEndGallons := nVolume

   // Put the volume in the C dtmf buffer for play back
   pd_putBuf(nChan, ALLTRIM(STR(nVolume, 8, 2)) )

   // Echo telephone key entry
   oChannel:aCurBlock := {{ || EchoInit(GALLONS) }, { || EchoProc() }}

   IF oChannel:nRepeat >= oChannel:oFlocation:ngradeCount
      // if the current repeat is higher than the number of grades we have,
	  // set it to the maximum so we can go on.
	  oChannel:nRepeat := VOICDICT->repeat+1
   ENDIF

   // Determine if reached end of file
   oChannel:aNextBlock := DictLoopTest()

ELSE
   // meter object was invalid
   LogInfo('Meter object invalid!')
   oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}

ENDIF

RETURN lRetVal

//
FUNCTION GasMoney()
// analyze entered fuel sales dollars
LOCAL cBuffer,;
	  lRetVal			:= .T.,;
      nSales,;
      oMeter

pd_dispMsg('GasMoney')

// Get the most recent stick reading
cBuffer := remTermDTMF( pd_getBuf(nChan) )

// Get the grade object
oMeter := oChannel:oFlocation:GetMeter( oChannel:nRepeat )

IF oMeter <> NIL
   cBuffer := ATREPL('*', cBuffer, '.')
   IF .NOT. '.' $ cBuffer
      nSales := VAL(cBuffer) / 100
   ELSE
      nSales := VAL(cBuffer)
   ENDIF

   // store in the grade object
   oMeter:nEndDollars := nSales

   // Put the volume in the C dtmf buffer for play back
   pd_putBuf( nChan, ALLTRIM(STR(nSales, 8, 2)) )
   // Echo telephone key entry
   oChannel:aCurBlock := {{ || EchoInit(DOLLARS) }, { || EchoProc() }}

   IF oChannel:nRepeat >= oChannel:oFlocation:ngradeCount
      // if the current repeat is higher than the number of grades we have,
	  // set it to the maximum so we can go on.
	  oChannel:nRepeat := VOICDICT->repeat+1
   ENDIF

   // Determine if reached end of file
   oChannel:aNextBlock := DictLoopTest()

ELSE
   // meter object was invalid
   LogInfo('Meter object invalid!')
   oChannel:aCurBlock := {{ || OnHookInit() }, { || OnHookProc() }}

ENDIF

RETURN lRetVal

//
FUNCTION SaveMeters()
// save sales information
LOCAL nRetVal

oChannel:oFlocation:saveMeters()

nRetVal := pd_putEvent(nChan, T_APPEVT, 0)

RETURN nRetVal

//
FUNCTION PlayFile(cFile)
// when function to play a file.
LOCAL nHandle,;
      nRetVal           := 0

DEFAULT cFile TO ''

pd_DispMsg('PlayFile():' + cFile)

IF .NOT. EMPTY(cFile)
   cFile := VoxExt(cFile)


   // Enter tank number for delivery, or press pound to review your tanks
   nRetVal := pd_play(nChan, cFile, @nHandle)
ELSE
   nRetVal := pd_putEvent(nChan, T_APPEVT, 0)
ENDIF


RETURN nRetVal

//
FUNCTION PlayClose()

// close playing the message and continue

// Close the most recently played file
pd_dispMsg('PlayClose()')

pd_VOXClose(oChannel:nHandle)

oChannel:aCurBlock := DictLoopTest()

RETURN NIL

//
FUNCTION UpdateOS()
// updates over/shorts in gasrecon for all tanks for the current store
LOCAL nTank,;                                    // current tank being processed
      nTankNum,;                                 // tank number loop counter
      oFL := oChannel:oFLocation,;               // fueling location object
      aSales,;                                   // array where sales is returned
      aWater                                     // array where water is returned

// say "one moment please"
SYSPLSWT2('Processing over/shorts')

// have not done meters yet in this session
LoadMeters()
LoadSticks()
LoadDeliv()

FOR nTankNum := 1 TO oFL:nTankCount
   nTank := oFL:getTank(nTankNum):nTank
   GASRECON->(DBSEEK(oFL:cTerritory + oFL:cStore + STR(nTank, 2) + DTOS(oFL:dCUrrent)) )
   IF .NOT. GASRECON->(FOUND())
      GASRECON->(DBAPPEND())
      REPLACE GASRECON->elsgroup WITH oFL:cTerritory,;
              GASRECON->elsstore   WITH oFL:cStore,;
              GASRECON->elsdate    WITH oFL:dCurrent,;
              GASRECON->elstime    WITH TIME(),;
              GASRECON->console_id WITH 9,;
              GASRECON->tank       WITH nTank
   ENDIF
   REPLACE GASRECON->begininv   WITH oFL:getEnding(nTankNum, oFL:dCurrent-1)
   REPLACE GASRECON->actualinv  WITH oFL:getTankInv(nTank)

   // update water for EPA
   aWater  := oFL:Water(nTank)
   REPLACE GASRECON->waterinch WITH aWater[1]
   REPLACE GASRECON->watergals WITH aWater[2]

   // update the delivery total
   REPLACE GASRECON->deliveries WITH oFL:UpdateDeliveries(nTank)

   // use entered sales to calculate over/short
   aSales := oFL:TotalMeters(nTank)
   REPLACE GASRECON->metertotal WITH aSales[1],;
           GASRECON->dollarssls WITH aSales[2]

   // calculate inventory
   REPLACE GASRECON->bookinv WITH GASRECON->begininv ;
                                + GASRECON->deliveries;
                                - GASRECON->metertotal;
                                + GASRECON->testgals;
                                - GASRECON->pump_out
   IF oFL:lBaseBook
      REPLACE GASRECON->overshort WITH GASRECON->actualinv - GASRECON->bookinv
   ELSE
      REPLACE GASRECON->overshort WITH GASRECON->bookinv - GASRECON->actualinv
   ENDIF

   // update running numbers for EPA
   REPLACE GASRECON->weekrunng  WITH oFL:SevenDayOS(nTank, oFL:dCurrent, GASRECON->overshort)
   REPLACE GASRECON->mtdrunng   WITH oFL:MTDOS     (nTank, oFL:dCurrent, GASRECON->overshort)

   REPLACE GASRECON->avepricepg WITH GASRECON->dollarssls / GASRECON->metertotal
   REPLACE GASRECON->baldone    WITH .T.

NEXT  // nTankNum

CLR_PLSWT2()

RETURN NIL

//
FUNCTION PlayOS()
// Initiate function to handle playing a tank's over/short
LOCAL nHandle           := pd_handGlobal(),;     // file handle of global.vap
      nRetVal,;
      oFL               := oChannel:oFlocation,; // pointer to fueling location object
      oTank,;
      aSeq              := {}                    // sequence of voice prompts to play

oTank := oChannel:oFlocation:getTank( oChannel:nRepeat )

IF oTank <> NIL
   pd_dispMsg('Play OS #' + NTOC(oTank:nTank) )

   GASRECON->(DBSEEK(oFL:cTerritory + oFL:cStore + STR(oTank:nTank, 2) + DTOS(oFL:dCurrent)) )
   IF .NOT. GASRECON->(FOUND())
      GASRECON->(DBAPPEND())
      REPLACE GASRECON->elsgroup   WITH oFL:cTerritory,;
              GASRECON->elsstore   WITH oFL:cStore,;
              GASRECON->elsdate    WITH oFL:dCurrent,;
              GASRECON->elstime    WITH TIME(),;
              GASRECON->console_id WITH 9,;
              GASRECON->tank       WITH oTank:nTank
   ENDIF

   // number
   AADD(aSeq, {nHandle, 407})

   // the number itself
   AADD(aSeq, {nHandle, oTank:nTank})

   // the tank's grade description index
   AADD(aSeq, {nHandle, oTank:nNameIdx} )

   // over/short value (won't handle a negative)
   pd_numSeq(nHandle, ABS(GASRECON->overshort), aSeq)

   // gallons
   AADD(aSeq, {nHandle, 417})

   // over/short
   AADD(aSeq, {nHandle, IIF(GASRECON->overshort > 0, 418, 419)})

   // Play the file
   nRetVal := pd_playSeq(nChan, aSeq)
   oChannel:nHandle := 0
ELSE
   nRetVal := pd_putEvent(nChan, T_APPEVT, 0)
ENDIF

RETURN nRetVal

//
FUNCTION GasVar()
// Valid function for reviewing over/short.  About the only thing this does
// is check to see if we have run out of tanks, then skipping to the last
// repeat.

LOCAL cDTMF,;
      lRetVal           := .T.

cDTMF := pd_getBuf(nChan)

pd_DispMsg('GasVar()')

IF oChannel:nRepeat >= oChannel:oFlocation:nTankCount
   // if the current repeat is higher than the number of tanks we have,
   // set it to the maximum so we can go on.
   oChannel:nRepeat := VOICDICT->repeat+1
ENDIF

// Determine if reached end of file
oChannel:aCurrentBlock := DictLoopTest()

RETURN lRetVal

// 
FUNCTION pd_numSeq(nHandle, nValue, aPlay)

// Function to build the array sequence of index numbers to play.  This
// function is defined as STATIC, because its purpose is not to be called
// from the application level.

LOCAL lThousand         := .F.,;
      nResult

#define MILLION    1000000
#define HTHOUSAND   100000
#define TTHOUSAND    10000
#define THOUSAND      1000
#define HUNDRED        100
#define TEN             10

// Simplest case nValue < 1
IF nValue < 1
  // Add to play array, say zero
  AADD(aPlay, {nHandle, 20}) // zero offset
ELSE
  // Divide by million, say 1, 2, ... 9 million
  IF (nResult := INT(nValue / MILLION)) > 0
    // Add to play array
    AADD(aPlay, {nHandle, nResult})  // 1 ... 9 offset
    AADD(aPlay, {nHandle, 32})       // million offset

    // Adjust remaining value
    nValue -= (nResult * MILLION)
  ENDIF

  // Divide by 100 thousand, say 1, 2, ... 9 hundred thousand
  IF (nResult := INT(nValue / HTHOUSAND)) > 0
    // Add to the play array
    AADD(aPlay, {nHandle, nResult})  // 1 ... 9 offset
    AADD(aPlay, {nHandle, 30})       // hundred offset
    lThousand := .T.  // don't know yet if need to append the word thousand

    // Adjust remaining value
    nValue -= (nResult * HTHOUSAND)
  ENDIF

  // Divide by 10 thousand, say 20, 30, ... 90
  IF (nResult := INT(nValue / TTHOUSAND)) > 1
    // Add to the play array
    AADD(aPlay, {nHandle, nResult + 20})  // 20 ... 90 offset
    lThousand := .T.  // don't know yet if need to append the word thousand

    // Adjust remaining value
    nValue -= (nResult * TTHOUSAND)
  ENDIF

  // Divide by a thousand, say 1, 2, ... 19 thousand
  IF (nResult := INT(nValue / THOUSAND)) > 0
    // Add to play array
    AADD(aPlay, {nHandle, nResult})  // 1 ... 19 offset
    lThousand := .T.                 // Ok to say the word thousand

    // Adjust remaining value
    nValue -= (nResult * THOUSAND)
  ENDIF

  IF lThousand
    // Say the word thousand
    AADD(aPlay, {nHandle, 31})  // thousand offset
  ENDIF

  // Divide by a hundred, say 1, 2, ... 9 hundred
  IF (nResult := INT(nValue / HUNDRED)) > 0
    // Add to play array
    AADD(aPlay, {nHandle, nResult})  // 1 ... 9 offset
    AADD(aPlay, {nHandle, 30})       // say hundred

    // Adjust remaining value
    nValue -= (nResult * HUNDRED)
  ENDIF

  // Divide by ten, say 20, 30, ... 90
  IF (nResult := INT(nValue / TEN)) > 1
    // Add to play array
    AADD(aPlay, {nHandle, nResult + 20})  // 20 ... 90 offset

    // Adjust remaining value
    nValue -= (nResult * TEN)
  ENDIF

  // Look at remaining integer result, say 1, 2, ... 19
  IF (nResult := INT(nValue)) > 0
    // Add to play array
    AADD(aPlay, {nHandle, nResult})  // 1 ... 19 offset

    // Adjust remaining value
    nValue -= nResult
  ENDIF
ENDIF

RETURN nValue

//
FUNCTION LoadSticks()
// load stick readings if they haven't already been

pd_DispMsg('LoadSticks()')

IF .NOT. oChannel:oFlocation:lSticksLoaded
   oChannel:oFlocation:LoadSticks()
ENDIF

RETURN .F.

//
FUNCTION LoadDeliv()
// load deliveries if they haven't already been

pd_DispMsg('LoadDeliv()')

IF .NOT. oChannel:oFlocation:lDelivLoaded
   oChannel:oFlocation:LoadDeliveries()
ENDIF

RETURN .F.

//
FUNCTION LoadMeters()
// load meters if they haven't already been

pd_DispMsg('LoadMeters()')

IF .NOT. oChannel:oFlocation:lMetersLoaded
   oChannel:oFlocation:LoadMeters()
ENDIF

RETURN .F.

