/**
  Ŀ
 ݳ                                                                          
 ݳ   Program : VOICCHAN.CLS                                                 
 ݳ   Purpose : Pyramid Voice channel object definitions and methods         
 ݳ Written By: Craig Snyder                                                 
 ݳThe procedures in this file are Copyright (C) 1988-1992 by the            
 ݳPinnacle dEVELOPMENT Corporation. These programs are the sole property of 
 ݳPinnacle dEVELOPMENT Corporation. They contain confidential information   
 ݳand are a trade secret of Pinnacle dEVELOPMENT Corporation. They are being
 ݳsupplied to you with the express understanding that the information       
 ݳcontained herein be held in confidence by you.  This software is not to be
 ݳcopied, distributed, or displayed to third parties without the express    
 ݳwritten consent of Pinnacle dEVELOPMENT Corporation, and must be returned 
 ݳupon request.  Any use of these programs without the express written      
 ݳconsent of Pinnacle dEVELOPEMENT Corporation, is strictly forbidden.      
 ݳThis software and any companion  documentation are protected by U.S.      
 ݳCopyright law (Title 17 United States Code).  Unauthorized reproduction   
 ݳand/or sale may result in imprisonment of up to one year and fines of up  
 ݳto $10,000 per infraction (17 USC 506).  Copyright infringers may also be 
 ݳsubject to civil liability.  Pinnacle dEVELOPMENT is an independent       
 ݳcorporation incorporated under the laws of the state of Texas, U.S.A.     
 
 

REVISION HISTORY:

 Date        Revision
09-21-92 CS Created.
01-04-93 PS Changes for Class(y) v2.0.
                                                                            */
#include "PINNSTD.CH"
#include "CLASS(Y).CH"

//
CREATE CLASS Channel

// Class definition for a Dialogic voice channel.

EXPORT:
  VAR cDictGroup            // dictionary group id
  VAR cGByeVox              // goodbye vox file
  VAR cGenMsgId             // id of general messages to play
  VAR cIntroVox             // introductory vox file
  VAR cLevel1               // security level 1 id
  VAR cLevel2               // security level 2 id
  VAR cLevel3               // security level 3 id
  VAR cSecVox               // security vox file to play
  VAR cUserMsgId            // id of user messages to play
  VAR nHandle               // current file handle being accessed
  VAR nGenMsgMax            // maximum level of general messages to play
  VAR nGetSecLev            // current security level to get
  VAR nRecNo                // DBF record number
  VAR nRepeat               // number of times to repeat a VOICDICT record
  VAR nSecRetry             // number of security retries
  VAR aCurBlock             // array of current initiate & process code blocks
  VAR cMenuVox              // main vox file to play menu options
  VAR nCurOption            // current menu option selected

  VAR aMenu                 // array of voice menu options
  VAR aNextBlock            // array of next initiate & process code blocks
  VAR nTimeOut              // max secs for entry.

  VAR lDates                // is the current cDictGroup keyed to date?
  VAR lShifts               // is the current cDictGroup keyed to shift?
  VAR dCurrent              // is the current cDictGroup date
  VAR nShift                // current shift number
  VAR nMaxShift             // maximum shift number
  VAR nTank                 // temp storage for tank number

  VAR oFLocation            // pointer to the current fueling location object for this channel
  VAR cTerritory            // oasis territory number

  METHOD Init               // initialize instance variables
  METHOD GotoCurRec         // DBGOTO(nRecNo)
  METHOD SkipRec            // DBGOTO(nRecNo), DBSKIP([<nSkip>])

END CLASS

//
METHOD Init(cGByeVox, cIntroVox, cSecVox, aCurBlock)

// Creates a Dialogic voice channel object and initializes instance variables.

DEFAULT cGByeVox   TO 'GOODBYE.VOX',;
        cIntroVox  TO 'INTRO.VOX',;
        cSecVox    TO 'LEVEL1.VOX',;
        aCurBlock  TO {}

::cDictGroup := ''          // dictionary group id
::cGByeVox   := cGByeVox    // goodbye vox file
::cGenMsgId  := ''          // id of general messages to play
::cIntroVox  := cIntroVox   // introductory vox file
::cLevel1    := ''          // security level 1 id
::cLevel2    := ''          // security level 2 id
::cLevel3    := ''          // security level 3 id
::cSecVox    := cSecVox     // current security vox file to play
::cUserMsgId := ''          // id of user messages to play
::nHandle    := 0           // current file handle being accessed
::nGenMsgMax := ''          // maximum level of general messages to play
::nGetSecLev := 1           // current security level to get
::nRecNo     := 1           // DBF record number
::nRepeat    := 1           // number of times to repeat a VOICDICT record
::nSecRetry  := 1           // number of security retries
::aCurBlock  := aCurBlock   // array of current initiate & process code blocks
::cMenuVox   := ''          // vox file to play for menu options
::aMenu      := {}          // array of voice menu options
::aNextBlock := {}          // array of next initiate & process code blocks
::nTimeOut   := 0           // timeout for dictionary lines.
::dCurrent   := DATE()      // the current date

RETURN self

//
METHOD FUNCTION GotoCurRec()

// Position the record pointer to the instance variable nRecNo record number.

DBGOTO(::nRecNo)

RETURN self

//
METHOD FUNCTION SkipRec(bEof, nSkip)

// Skip the record pointer in the direction of parameter nSkip.

LOCAL lRetVal

DEFAULT bEof  TO { || .T. },;
        nSkip TO 1

// Go to the current record, skip, and save the new current record number
DBGOTO(::nRecNo)
DBSKIP(nSkip)
::nRecNo := RECNO()

// Evaluate end of file condition block
lRetVal := EVAL(bEof)

RETURN lRetVal
